/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 79 "cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "route.h"
#include "dprint.h"
#include "cfg_pp.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "pt_scaling.h"
#include "dset.h"
#include "pvar.h"
#include "blacklists.h"
#include "xlog.h"
#include "db/db_insertq.h"
#include "bin_interface.h"
#include "net/trans.h"
#include "config.h"
#include "mem/rpm_mem.h"
#include "poll_types.h"

#ifdef SHM_EXTRA_STATS
#include "mem/module_info.h"
#endif

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#undef MIN
#undef MAX

extern int yylex();
static void yyerror(char* s);
static void yyerrorf(char* fmt, ...);
static char* tmp;
static int i_tmp, rc;
static struct socket_id* lst_tmp;
static int rt;  /* Type of route block for find_export */
static str s_tmp;
static str tstr;
static struct net* net_tmp;
static pv_spec_t *spec;
static pv_elem_t *elem;
static struct bl_rule *bl_head = 0;
static struct bl_rule *bl_tail = 0;
static struct script_route_ref *rt_ref = NULL;

action_elem_t elems[MAX_ACTION_ELEMS];
static action_elem_t route_elems[MAX_ACTION_ELEMS];
action_elem_t *a_tmp;

struct port_range {
	int min;
	int max;
	struct port_range *next;
} *pr_tmp;

static inline void warn(char* s);
static struct socket_id* mk_listen_id(char*, enum sip_protos, int);
static struct socket_id* mk_listen_id_range(char*, enum sip_protos, struct port_range *);
static struct socket_id* set_listen_id_adv(struct socket_id *, char *, int);
static struct multi_str *new_string(char *s);
static struct port_range* mk_port_range(int, int);
static int parse_ipnet(char *in, int len, struct net **ipnet);

extern int line;
extern int column;
extern int startcolumn;
extern char *finame;

struct listen_param {
	enum si_flags flags;
	int workers;
	struct socket_id *socket;
	char *tag;
	char *auto_scaling_profile;
} p_tmp;
static void fill_socket_id(struct listen_param *param, struct socket_id *s);

union route_name_var {
	int iname;
	struct _pv_spec *sname;
	struct _pv_elem *ename;
	void *data;
} rn_tmp;

#ifndef SHM_EXTRA_STATS
struct multi_str{
	char *s;
	struct multi_str* next;
};
#else
static struct multi_str *tmp_mod;
#endif

#define get_cfg_file_name \
	((finame) ? finame : cfg_file ? cfg_file : "default")



#define mk_action_(_res, _type, _no, _elems) \
	do { \
		_res = mk_action(_type, _no, _elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action0(_res, _type) \
	do { \
		_res = mk_action(_type, 0, 0, line, get_cfg_file_name); \
	} while(0)
#define mk_action1(_res, _type, _p1_type, _p1) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		_res = mk_action(_type, 1, elems, line, get_cfg_file_name); \
	} while(0)
#define	mk_action2(_res, _type, _p1_type, _p2_type, _p1, _p2) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		_res = mk_action(_type, 2, elems, line, get_cfg_file_name); \
	} while(0)
#define mk_action3(_res, _type, _p1_type, _p2_type, _p3_type, _p1, _p2, _p3) \
	do { \
		elems[0].type = _p1_type; \
		elems[0].u.data = _p1; \
		elems[1].type = _p2_type; \
		elems[1].u.data = _p2; \
		elems[2].type = _p3_type; \
		elems[2].u.data = _p3; \
		_res = mk_action(_type, 3, elems, line, get_cfg_file_name); \
	} while(0)

extern int cfg_parse_only_routes;
#define IFOR(_instr) \
	if (cfg_parse_only_routes==1) {_instr;break;}


#line 225 "cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CFG_TAB_H_INCLUDED
# define YY_YY_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    DROP = 258,
    ASSERT = 259,
    EXIT = 260,
    RETURN = 261,
    LOG_TOK = 262,
    ERROR = 263,
    ROUTE = 264,
    ROUTE_FAILURE = 265,
    ROUTE_ONREPLY = 266,
    ROUTE_BRANCH = 267,
    ROUTE_ERROR = 268,
    ROUTE_LOCAL = 269,
    ROUTE_STARTUP = 270,
    ROUTE_TIMER = 271,
    ROUTE_EVENT = 272,
    IF = 273,
    ELSE = 274,
    SWITCH = 275,
    CASE = 276,
    DEFAULT = 277,
    BREAK = 278,
    WHILE = 279,
    FOR = 280,
    IN = 281,
    READONLY = 282,
    EXPIRE = 283,
    NULLV = 284,
    XDBG = 285,
    XLOG = 286,
    XLOG_BUF_SIZE = 287,
    XLOG_FORCE_COLOR = 288,
    XLOG_PRINT_LEVEL = 289,
    XLOG_LEVEL = 290,
    PV_PRINT_BUF_SIZE = 291,
    DEBUG_MODE = 292,
    ENABLE_ASSERTS = 293,
    ABORT_ON_ASSERT = 294,
    LOGLEVEL = 295,
    LOGPREFIX = 296,
    LOGSTDOUT = 297,
    LOGSTDERROR = 298,
    STDERROR_ENABLED = 299,
    SYSLOG_ENABLED = 300,
    LOG_EVENT_ENABLED = 301,
    STDERROR_LEVEL_FILTER = 302,
    SYSLOG_LEVEL_FILTER = 303,
    LOG_EVENT_LEVEL_FILTER = 304,
    STDERROR_FORMAT = 305,
    SYSLOG_FORMAT = 306,
    LOG_JSON_BUF_SIZE = 307,
    LOG_MSG_BUF_SIZE = 308,
    LOGFACILITY = 309,
    SYSLOG_FACILITY = 310,
    LOGNAME = 311,
    SYSLOG_NAME = 312,
    AVP_ALIASES = 313,
    LISTEN = 314,
    SOCKET = 315,
    MEMGROUP = 316,
    ALIAS = 317,
    AUTO_ALIASES = 318,
    TAG = 319,
    DNS = 320,
    REV_DNS = 321,
    DNS_TRY_IPV6 = 322,
    DNS_TRY_NAPTR = 323,
    DNS_RETR_TIME = 324,
    DNS_RETR_NO = 325,
    DNS_SERVERS_NO = 326,
    DNS_USE_SEARCH = 327,
    MAX_WHILE_LOOPS = 328,
    UDP_WORKERS = 329,
    CHECK_VIA = 330,
    SHM_HASH_SPLIT_PERCENTAGE = 331,
    SHM_SECONDARY_HASH_SIZE = 332,
    MEM_WARMING_ENABLED = 333,
    MEM_WARMING_PATTERN_FILE = 334,
    MEM_WARMING_PERCENTAGE = 335,
    RPM_MEM_FILE = 336,
    RPM_MEM_SIZE = 337,
    MEMLOG = 338,
    MEMDUMP = 339,
    SHM_MEMLOG_SIZE = 340,
    EXECMSGTHRESHOLD = 341,
    EXECDNSTHRESHOLD = 342,
    TCPTHRESHOLD = 343,
    EVENT_SHM_THRESHOLD = 344,
    EVENT_PKG_THRESHOLD = 345,
    QUERYBUFFERSIZE = 346,
    QUERYFLUSHTIME = 347,
    SIP_WARNING = 348,
    SERVER_SIGNATURE = 349,
    SERVER_HEADER = 350,
    USER_AGENT_HEADER = 351,
    LOADMODULE = 352,
    MPATH = 353,
    MODPARAM = 354,
    MAXBUFFER = 355,
    CHROOT = 356,
    WDIR = 357,
    MHOMED = 358,
    POLL_METHOD = 359,
    TCP_ACCEPT_ALIASES = 360,
    TCP_WORKERS = 361,
    TCP_CONNECT_TIMEOUT = 362,
    TCP_CON_LIFETIME = 363,
    TCP_SOCKET_BACKLOG = 364,
    TCP_MAX_CONNECTIONS = 365,
    TCP_NO_NEW_CONN_BFLAG = 366,
    TCP_NO_NEW_CONN_RPLFLAG = 367,
    TCP_KEEPALIVE = 368,
    TCP_KEEPCOUNT = 369,
    TCP_KEEPIDLE = 370,
    TCP_KEEPINTERVAL = 371,
    TCP_MAX_MSG_TIME = 372,
    TCP_PARALLEL_READ_ON_WORKERS = 373,
    ADVERTISED_ADDRESS = 374,
    ADVERTISED_PORT = 375,
    DISABLE_CORE = 376,
    OPEN_FD_LIMIT = 377,
    MCAST_LOOPBACK = 378,
    MCAST_TTL = 379,
    TOS = 380,
    DISABLE_DNS_FAILOVER = 381,
    DISABLE_DNS_BLACKLIST = 382,
    DST_BLACKLIST = 383,
    DISABLE_STATELESS_FWD = 384,
    DB_VERSION_TABLE = 385,
    DB_DEFAULT_URL = 386,
    DB_MAX_ASYNC_CONNECTIONS = 387,
    DISABLE_503_TRANSLATION = 388,
    SYNC_TOKEN = 389,
    ASYNC_TOKEN = 390,
    LAUNCH_TOKEN = 391,
    AUTO_SCALING_PROFILE = 392,
    AUTO_SCALING_CYCLE = 393,
    TIMER_WORKERS = 394,
    EQUAL = 395,
    EQUAL_T = 396,
    GT = 397,
    LT = 398,
    GTE = 399,
    LTE = 400,
    DIFF = 401,
    MATCH = 402,
    NOTMATCH = 403,
    COLONEQ = 404,
    PLUSEQ = 405,
    MINUSEQ = 406,
    SLASHEQ = 407,
    MULTEQ = 408,
    MODULOEQ = 409,
    BANDEQ = 410,
    BOREQ = 411,
    BXOREQ = 412,
    OR = 413,
    AND = 414,
    BOR = 415,
    BAND = 416,
    BXOR = 417,
    BLSHIFT = 418,
    BRSHIFT = 419,
    PLUS = 420,
    MINUS = 421,
    SLASH = 422,
    MULT = 423,
    MODULO = 424,
    NOT = 425,
    BNOT = 426,
    RPAREN = 427,
    NUMBER = 428,
    ZERO = 429,
    ID = 430,
    STRING = 431,
    SCRIPTVAR = 432,
    IPV6ADDR = 433,
    IPV4ADDR = 434,
    IPNET = 435,
    COMMA = 436,
    SEMICOLON = 437,
    LPAREN = 438,
    LBRACE = 439,
    RBRACE = 440,
    LBRACK = 441,
    RBRACK = 442,
    AS = 443,
    USE_WORKERS = 444,
    USE_AUTO_SCALING_PROFILE = 445,
    MAX = 446,
    MIN = 447,
    DOT = 448,
    CR = 449,
    COLON = 450,
    ANY = 451,
    ANYCAST = 452,
    FRAG = 453,
    REUSE_PORT = 454,
    SCRIPTVARERR = 455,
    SCALE_UP_TO = 456,
    SCALE_DOWN_TO = 457,
    ON = 458,
    CYCLES = 459,
    CYCLES_WITHIN = 460,
    PERCENTAGE = 461
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 239 "cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct listen_param* listen_param;
	struct _pv_spec *specval;
	struct multi_str* multistr;
	struct port_range* portrange;

#line 487 "cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 504 "cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  234
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2287

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  207
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  88
/* YYNRULES -- Number of rules.  */
#define YYNRULES  524
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  999

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   461

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   510,   510,   513,   514,   515,   518,   519,   520,   520,
     521,   521,   522,   522,   523,   523,   524,   524,   525,   525,
     526,   526,   527,   527,   528,   528,   530,   533,   548,   557,
     572,   573,   576,   577,   591,   596,   606,   607,   610,   623,
     632,   639,   641,   642,   643,   647,   649,   651,   656,   664,
     666,   668,   670,   672,   677,   684,   686,   688,   690,   694,
     697,   698,   701,   703,   705,   711,   714,   717,   720,   723,
     726,   729,   734,   735,   738,   739,   739,   746,   747,   749,
     750,   753,   761,   770,   776,   783,   789,   796,   802,   809,
     815,   822,   828,   837,   838,   839,   842,   843,   844,   847,
     848,   851,   852,   853,   857,   865,   873,   879,   887,   891,
     903,   904,   905,   906,   907,   908,   923,   925,   928,   929,
     950,   951,   962,   963,   974,   975,   984,   985,   991,   992,
     998,   999,  1001,  1002,  1027,  1052,  1060,  1061,  1069,  1070,
    1077,  1078,  1084,  1085,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
    1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1116,
    1117,  1120,  1124,  1125,  1126,  1134,  1142,  1150,  1158,  1166,
    1174,  1182,  1190,  1198,  1206,  1209,  1210,  1213,  1214,  1215,
    1216,  1217,  1218,  1219,  1220,  1221,  1222,  1223,  1224,  1225,
    1226,  1236,  1237,  1251,  1252,  1253,  1254,  1255,  1256,  1257,
    1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1276,
    1286,  1287,  1292,  1293,  1296,  1300,  1301,  1306,  1307,  1310,
    1311,  1314,  1315,  1318,  1319,  1326,  1327,  1334,  1336,  1339,
    1340,  1343,  1344,  1347,  1350,  1357,  1358,  1365,  1366,  1373,
    1374,  1376,  1377,  1381,  1382,  1385,  1386,  1388,  1389,  1391,
    1393,  1395,  1396,  1397,  1398,  1400,  1401,  1410,  1413,  1423,
    1426,  1470,  1471,  1476,  1478,  1480,  1481,  1487,  1489,  1503,
    1505,  1508,  1509,  1512,  1513,  1520,  1521,  1528,  1529,  1533,
    1561,  1562,  1564,  1565,  1568,  1569,  1572,  1573,  1583,  1593,
    1595,  1597,  1598,  1600,  1601,  1603,  1606,  1608,  1611,  1612,
    1615,  1617,  1620,  1623,  1627,  1628,  1634,  1640,  1646,  1650,
    1651,  1654,  1670,  1686,  1687,  1690,  1696,  1706,  1716,  1727,
    1730,  1739,  1744,  1767,  1772,  1780,  1796,  1799,  1805,  1808,
    1816,  1822,  1825,  1831,  1834,  1842,  1845,  1853,  1856,  1864,
    1867,  1880,  1883,  1889,  1894,  1895,  1896,  1897,  1898,  1899,
    1902,  1903,  1906,  1907,  1908,  1909,  1911,  1912,  1915,  1916,
    1919,  1920,  1921,  1924,  1940,  1945,  1946,  1947,  1949,  1954,
    1957,  1960,  1963,  1966,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1985,  1986,  1987,  1988,  1989,  1990,
    1993,  1996,  1999,  2002,  2005,  2008,  2011,  2014,  2017,  2020,
    2023,  2026,  2039,  2052,  2067,  2068,  2069,  2070,  2071,  2074,
    2075,  2076,  2079,  2080,  2081,  2084,  2085,  2086,  2090,  2091,
    2092,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2116,  2124,
    2134,  2142,  2152,  2160,  2178,  2187,  2188,  2190,  2191,  2194,
    2200,  2206,  2212,  2220,  2223,  2226,  2231,  2241,  2248,  2255,
    2265,  2270,  2277,  2287,  2292,  2299,  2311,  2316,  2321,  2326,
    2331,  2341,  2351,  2361,  2373,  2391,  2422,  2426,  2432,  2435,
    2436,  2437,  2438,  2439,  2441,  2443,  2445,  2447,  2449,  2450,
    2453,  2459,  2460,  2462,  2468,  2469,  2471,  2475,  2494,  2495,
    2497,  2520,  2556,  2558,  2561,  2563,  2565,  2567,  2569,  2571,
    2573,  2580,  2587,  2594,  2601
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DROP", "ASSERT", "EXIT", "RETURN",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_FAILURE", "ROUTE_ONREPLY",
  "ROUTE_BRANCH", "ROUTE_ERROR", "ROUTE_LOCAL", "ROUTE_STARTUP",
  "ROUTE_TIMER", "ROUTE_EVENT", "IF", "ELSE", "SWITCH", "CASE", "DEFAULT",
  "BREAK", "WHILE", "FOR", "IN", "READONLY", "EXPIRE", "NULLV", "XDBG",
  "XLOG", "XLOG_BUF_SIZE", "XLOG_FORCE_COLOR", "XLOG_PRINT_LEVEL",
  "XLOG_LEVEL", "PV_PRINT_BUF_SIZE", "DEBUG_MODE", "ENABLE_ASSERTS",
  "ABORT_ON_ASSERT", "LOGLEVEL", "LOGPREFIX", "LOGSTDOUT", "LOGSTDERROR",
  "STDERROR_ENABLED", "SYSLOG_ENABLED", "LOG_EVENT_ENABLED",
  "STDERROR_LEVEL_FILTER", "SYSLOG_LEVEL_FILTER", "LOG_EVENT_LEVEL_FILTER",
  "STDERROR_FORMAT", "SYSLOG_FORMAT", "LOG_JSON_BUF_SIZE",
  "LOG_MSG_BUF_SIZE", "LOGFACILITY", "SYSLOG_FACILITY", "LOGNAME",
  "SYSLOG_NAME", "AVP_ALIASES", "LISTEN", "SOCKET", "MEMGROUP", "ALIAS",
  "AUTO_ALIASES", "TAG", "DNS", "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR",
  "DNS_RETR_TIME", "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH",
  "MAX_WHILE_LOOPS", "UDP_WORKERS", "CHECK_VIA",
  "SHM_HASH_SPLIT_PERCENTAGE", "SHM_SECONDARY_HASH_SIZE",
  "MEM_WARMING_ENABLED", "MEM_WARMING_PATTERN_FILE",
  "MEM_WARMING_PERCENTAGE", "RPM_MEM_FILE", "RPM_MEM_SIZE", "MEMLOG",
  "MEMDUMP", "SHM_MEMLOG_SIZE", "EXECMSGTHRESHOLD", "EXECDNSTHRESHOLD",
  "TCPTHRESHOLD", "EVENT_SHM_THRESHOLD", "EVENT_PKG_THRESHOLD",
  "QUERYBUFFERSIZE", "QUERYFLUSHTIME", "SIP_WARNING", "SERVER_SIGNATURE",
  "SERVER_HEADER", "USER_AGENT_HEADER", "LOADMODULE", "MPATH", "MODPARAM",
  "MAXBUFFER", "CHROOT", "WDIR", "MHOMED", "POLL_METHOD",
  "TCP_ACCEPT_ALIASES", "TCP_WORKERS", "TCP_CONNECT_TIMEOUT",
  "TCP_CON_LIFETIME", "TCP_SOCKET_BACKLOG", "TCP_MAX_CONNECTIONS",
  "TCP_NO_NEW_CONN_BFLAG", "TCP_NO_NEW_CONN_RPLFLAG", "TCP_KEEPALIVE",
  "TCP_KEEPCOUNT", "TCP_KEEPIDLE", "TCP_KEEPINTERVAL", "TCP_MAX_MSG_TIME",
  "TCP_PARALLEL_READ_ON_WORKERS", "ADVERTISED_ADDRESS", "ADVERTISED_PORT",
  "DISABLE_CORE", "OPEN_FD_LIMIT", "MCAST_LOOPBACK", "MCAST_TTL", "TOS",
  "DISABLE_DNS_FAILOVER", "DISABLE_DNS_BLACKLIST", "DST_BLACKLIST",
  "DISABLE_STATELESS_FWD", "DB_VERSION_TABLE", "DB_DEFAULT_URL",
  "DB_MAX_ASYNC_CONNECTIONS", "DISABLE_503_TRANSLATION", "SYNC_TOKEN",
  "ASYNC_TOKEN", "LAUNCH_TOKEN", "AUTO_SCALING_PROFILE",
  "AUTO_SCALING_CYCLE", "TIMER_WORKERS", "EQUAL", "EQUAL_T", "GT", "LT",
  "GTE", "LTE", "DIFF", "MATCH", "NOTMATCH", "COLONEQ", "PLUSEQ",
  "MINUSEQ", "SLASHEQ", "MULTEQ", "MODULOEQ", "BANDEQ", "BOREQ", "BXOREQ",
  "OR", "AND", "BOR", "BAND", "BXOR", "BLSHIFT", "BRSHIFT", "PLUS",
  "MINUS", "SLASH", "MULT", "MODULO", "NOT", "BNOT", "RPAREN", "NUMBER",
  "ZERO", "ID", "STRING", "SCRIPTVAR", "IPV6ADDR", "IPV4ADDR", "IPNET",
  "COMMA", "SEMICOLON", "LPAREN", "LBRACE", "RBRACE", "LBRACK", "RBRACK",
  "AS", "USE_WORKERS", "USE_AUTO_SCALING_PROFILE", "MAX", "MIN", "DOT",
  "CR", "COLON", "ANY", "ANYCAST", "FRAG", "REUSE_PORT", "SCRIPTVARERR",
  "SCALE_UP_TO", "SCALE_DOWN_TO", "ON", "CYCLES", "CYCLES_WITHIN",
  "PERCENTAGE", "$accept", "cfg", "statements", "statement", "$@1", "$@2",
  "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9", "listen_id", "host_sep",
  "host", "proto", "port", "portrange", "snumber", "phostport",
  "phostportrange", "alias_def", "id_lst", "listen_id_def",
  "socket_def_param", "socket_def_params", "socket_def", "$@10",
  "any_proto", "multi_string", "blst_elem", "blst_def", "blst_flag",
  "blst_flags", "blst_elem_list", "auto_scale_profile_def", "assign_stm",
  "module_stm", "ip", "ipv4", "ipv6addr", "ipv6", "ipnet", "folded_string",
  "route_name", "route_name_var", "route_stm", "failure_route_stm",
  "onreply_route_stm", "branch_route_stm", "error_route_stm",
  "local_route_stm", "startup_route_stm", "timer_route_stm",
  "event_route_stm", "exp", "equalop", "compop", "matchop", "intop",
  "strop", "script_var", "exp_elem", "exp_cond", "assignop", "assignexp",
  "assign_cmd", "exp_stm", "brk_stm", "stm", "actions", "brk_actions",
  "action", "brk_action", "brk_if_cmd", "if_cmd", "while_cmd",
  "foreach_cmd", "switch_cmd", "switch_stm", "case_stms", "case_stm",
  "default_stm", "func_param", "route_param", "async_func", "cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461
};
# endif

#define YYPACT_NINF -854

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-854)))

#define YYTABLE_NINF -464

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2093,   -69,   -21,   -15,    14,    26,    34,   212,   229,   239,
     276,   293,   298,   314,   349,   395,   458,   474,   507,   520,
     541,   609,   619,   624,   629,   634,   640,   648,   656,   659,
     662,   663,   674,   675,   683,    35,    36,   358,   512,   564,
     610,   687,   699,   706,   710,   722,   728,   729,   730,   742,
     748,   758,   765,   775,   776,   780,   784,   794,   804,   830,
     840,   841,   843,   844,   850,   106,   853,    32,   856,   860,
     861,   869,   870,   882,   885,   887,   888,   893,   898,   908,
     910,   911,   913,   915,   916,   929,   930,   931,   933,   934,
     936,   939,   941,   943,   628,   644,   944,   945,   948,   949,
     952,   966,   967,   969,   971,  -854,   147,  1930,  -854,   187,
     167,   203,   679,   690,   608,   731,   751,   809,  -854,  -854,
    -854,    88,   142,   169,   379,   274,   353,   355,   370,   199,
     111,   373,   374,   375,   376,   377,   426,   447,   468,   653,
     655,   388,   407,    87,   116,   112,   120,   122,   160,   707,
      68,   414,   423,   424,  -854,   714,  -854,   902,  -854,   940,
    -854,   950,  -854,   962,  -854,   963,   442,   443,   444,   445,
     454,   457,   136,   469,   140,   480,   473,   478,   484,   481,
     482,   483,   489,   491,   492,   493,   499,   501,   148,   150,
    -854,  -854,   151,  -854,   793,   510,    37,   103,   511,   105,
     513,   514,   515,   516,   526,   528,   183,   186,   558,   559,
     561,   565,   566,   567,   135,   568,   569,   580,   581,   583,
     172,  -854,   964,  -854,   965,   864,   968,   152,   155,   584,
     585,   188,   588,   973,  -854,   -69,  -854,    46,  -854,    25,
    -854,   139,  -854,    48,  -854,    45,  -854,    61,  -854,    72,
    -854,    56,  -854,    64,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,   978,   985,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,   917,
     696,  -854,  -854,  -854,   921,  -854,  1117,   927,  -854,  -854,
    -854,   947,   976,  -854,  -100,   979,  -854,   997,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,   972,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,   958,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,   987,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,   -93,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,   980,  -854,  -854,  -854,
     989,  -854,  1752,   550,  -854,   550,  -854,  1752,   550,  -854,
     550,  -854,  1752,  -854,  1752,  -854,  1752,  -854,   550,  -854,
     550,  -854,  -854,   819,   743,   163,  -854,   953,   587,  -854,
     192,  1007,   587,  -854,  1011,  1016,  1013,   651,  1015,  -854,
    1022,  1021,  1024,  1025,  1026,   -35,    44,    69,    74,  1027,
    1030,  1031,  1033,  1035,  1036,  1037,  1040,    77,  -854,  -854,
    -854,  1235,  1042,   601,  -854,  -854,  -854,  -854,  -854,    22,
    -854,  -854,  -854,  1043,  1051,   786,  1052,  1053,   829,   872,
     905,  1060,  1055,  1048,  1049,  1070,   587,  1074,  1075,  -854,
    -854,  -854,   743,  -854,  -854,  1073,  -854,  -854,  1056,  -854,
    -854,  1062,  -854,  1081,  -854,  -854,  -854,  -854,  -854,   -36,
     974,  1061,  -854,  1083,  1309,  1091,   234,  -854,  -854,  -854,
     184,  -854,   168,  -854,    33,  1309,  -116,  1309,  -116,  1092,
    1093,  1095,  1095,  -854,    93,  1237,  1242,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  1523,  -854,  -854,  -854,  -854,
    -854,  -854,  1089,  1099,  -854,  1100,  1101,  -854,  -854,  -854,
    1113,  1103,   602,   627,  -854,  1094,  -854,  -854,  -854,  -854,
    -854,    43,    55,   606,   651,  -854,   796,  -854,   665,  -854,
    -854,     9,  -854,  -854,  1115,  -854,  1309,  1309,  1567,  1523,
    -854,   -26,  1701,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  1120,  1122,  1127,  1129,  1124,  1134,  1128,  1136,  -854,
    -109,  -854,   263,  1139,   338,  1293,   -58,   277,   676,   289,
      85,  1140,   -52,  1148,  -854,  -854,   551,  -854,  -854,   -37,
    -854,  -854,  1523,  -854,  1523,  -854,   811,  -854,  1395,  -854,
    1752,  1752,  1752,  1752,  1135,  1752,  -854,  1157,  1143,  -854,
    1143,   639,  -854,  -854,  -854,  -854,  -854,  -854,   487,  1154,
     504,  -854,   665,  -854,  -854,  -854,  1147,     7,  -854,   721,
    -854,  1161,  -854,   563,  -854,   942,   899,  1309,  1309,  1153,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,   642,   -50,
    -854,   199,   -14,  -854,  -854,  -854,  -854,  1155,  -854,  1158,
    -854,  -854,   812,  1596,  1152,  1411,  -116,  -854,  -854,  -854,
    -854,  -854,  1162,  -854,  -854,   291,   550,  -854,   550,  -854,
    -854,  -854,  -854,  -854,   858,  -854,  1299,  1523,  1523,  1523,
    1523,  1523,  1523,  1523,  1523,  1523,  1523,  1012,  1090,  1125,
    1160,  1159,  1197,  1168,  1171,  -854,  1143,  -854,  -854,  -854,
    1165,   251,   866,  -854,   -81,  -854,  1322,  -854,  -854,  -854,
    -854,  -854,  1176,  -854,  -854,  -854,  -854,  -854,  1187,  1189,
    -854,  -854,  -854,  -854,   486,  1630,  1343,  -854,  1344,  1183,
    1185,  -854,  1493,  1186,  -854,  -854,  -854,  -854,  -854,  -854,
     102,  1198,   572,   637,  1199,  -854,   530,   684,   686,  -854,
    -854,  -854,  -854,   935,   935,   935,   935,   935,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  1752,  -854,  -854,
    1203,   866,  -854,   -81,   691,  1201,  1204,  -854,  -854,  -854,
    -854,   826,  -854,  1228,  1596,   632,  1191,   382,  -854,  1309,
    -854,  -854,   570,  -854,  -854,  -854,  -854,  1411,  -854,  -854,
    -854,  -854,  -854,  1205,  -854,  1207,  1273,  1208,   745,  1221,
    -854,   -81,  -854,  -122,  -854,  -854,  -854,  -854,  -854,  -854,
    1200,  1206,  -854,  1209,  -854,  -854,   571,  -854,  -854,  -854,
    -854,  1222,  1224,  -854,  -854,  -854,   -81,  -854,   746,  1178,
    1225,  1704,  1704,  1704,  1411,  -854,  -854,   747,  -854,  1223,
    1227,  1210,   500,   533,   689,  1383,  -854,  1230,  1239,  1218,
    1234,  1411,  1250,  -854,  1251,  1220,  -854,  -854,  1256,  1253,
    1402,  1263,  1260,  1412,  1236,  1265,  -854,  1243,  -854
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    26,     0,     0,     4,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     6,     7,
     312,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   152,     0,   154,     0,   156,     0,
     158,     0,   160,     0,   162,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     314,   313,     0,   318,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   294,     0,   296,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     5,     3,     0,     9,     0,
      11,     0,    13,     0,    15,     0,    17,     0,    19,     0,
      21,     0,    23,     0,    25,   261,   258,   262,   259,   263,
     260,   265,     0,     0,    42,   264,   257,   256,   116,   115,
     112,   111,   114,   113,   108,   110,   109,   118,   117,   120,
     119,   122,   121,   124,   123,   126,   125,   128,   127,   130,
     129,   132,   131,   133,   134,   136,   135,   138,   137,   140,
     139,   142,   141,   144,   143,   146,   145,   269,    35,     0,
      74,   268,   267,   266,     0,   273,     0,    32,    28,   322,
     321,     0,     0,    55,    29,     0,    59,    60,   272,    27,
     319,   323,   320,   275,   274,   148,   147,   150,   149,   151,
     153,   155,   157,   159,   161,   164,   163,   169,   167,   173,
     172,   175,   174,   177,   176,   179,   178,   181,   180,   183,
     182,   185,   184,   187,   186,   189,   188,   193,   192,   191,
     190,   195,   194,   197,   196,   199,   198,   201,   200,   203,
     202,   205,   204,   207,   206,   209,   208,   251,   250,   253,
     252,   255,   254,   292,   291,     0,   166,   165,   212,   211,
     210,   215,   214,   213,   217,   216,   220,   218,   219,   222,
     221,   225,   223,   227,   226,   229,   228,   231,   230,   233,
     232,   235,   234,   237,   236,   239,   238,   245,   244,   247,
     246,   249,   248,   241,   240,   243,   242,   277,    32,   276,
     279,   278,   281,   280,   283,   282,   285,   284,   287,   286,
     290,   288,   289,   293,   295,    95,   299,   301,   300,   303,
     302,   305,   304,   307,   306,   309,     0,   308,   311,   310,
     170,   336,     0,     0,   338,     0,   341,     0,     0,   343,
       0,   345,     0,   347,     0,   349,     0,   351,     0,   353,
       0,    43,    44,     0,     0,     0,    48,     0,     0,    31,
       0,     0,     0,    61,     0,     0,     0,     0,     0,   298,
       0,     0,   489,     0,   491,   498,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   373,   437,
     374,     0,     0,     0,   426,   432,   433,   434,   435,     0,
     330,   329,   331,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    49,    50,     0,     0,     0,     0,    65,
      66,    67,    72,    76,   271,    79,   270,   324,    56,    34,
      33,    45,   168,     0,   224,    98,    96,    97,   100,    95,
       0,     0,   171,     0,     0,     0,     0,   495,   493,   501,
       0,   504,     0,   508,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   513,     0,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,     0,   436,   427,   334,   425,
     438,   431,     0,     0,   339,     0,     0,   344,   346,   348,
       0,     0,     0,     0,    70,    62,    69,    68,    71,    73,
      80,     0,     0,     0,     0,   297,     0,   325,     0,    94,
     102,     0,   326,    91,     0,   490,     0,     0,     0,     0,
     377,     0,   378,   359,   375,   416,   376,   415,   414,   492,
     497,     0,     0,     0,     0,     0,     0,     0,     0,   332,
       0,   333,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   510,   465,   467,   470,   473,     0,
     412,   413,     0,   395,     0,   394,   396,   397,   411,   398,
       0,     0,     0,     0,     0,     0,    53,    41,    51,    54,
      52,     0,    58,    36,    37,    57,    47,    46,     0,     0,
       0,    99,     0,    92,    77,    78,     0,     0,   103,     0,
      93,     0,   356,     0,   418,     0,     0,     0,     0,     0,
     360,   362,   363,   364,   365,   361,   366,   367,   368,   369,
     372,     0,     0,   496,   494,   502,   499,     0,   505,     0,
     509,   506,     0,     0,     0,     0,     0,   514,   327,   515,
     328,   516,     0,   517,   487,     0,     0,   524,     0,   512,
     468,   471,   474,   511,   469,   409,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    64,    63,   315,   317,   316,
       0,     0,     0,    89,     0,   101,     0,   357,   417,   358,
     355,   354,     0,   382,   383,   381,   380,   379,     0,     0,
     478,   476,   477,   479,     0,     0,   450,   422,     0,     0,
       0,   446,     0,     0,   452,   419,   441,   442,   443,   444,
       0,     0,     0,     0,     0,   484,     0,     0,     0,   466,
     472,   475,   410,   405,   404,   406,   407,   408,   399,   400,
     402,   401,   403,   335,   337,   340,   342,     0,   352,    40,
      39,     0,    90,     0,     0,     0,     0,   488,   500,   503,
     507,     0,   424,     0,     0,     0,     0,   456,   458,     0,
     439,   421,     0,   429,   445,   447,   440,     0,   518,   519,
     486,   485,   520,     0,   523,     0,     0,     0,     0,     0,
      85,     0,    87,     0,   483,   480,   481,   482,   423,   451,
       0,     0,   454,     0,   457,   455,     0,   430,   420,   428,
     453,     0,     0,   350,    38,    86,     0,    88,     0,   107,
       0,   462,   460,   464,     0,   521,   522,     0,    83,     0,
       0,   106,     0,     0,     0,   448,    84,     0,     0,     0,
       0,     0,     0,    81,     0,     0,   449,    82,     0,     0,
       0,     0,     0,     0,     0,     0,   105,     0,   104
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -854,  -854,  -854,  1332,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -208,  -854,  -854,  -149,  -622,  -582,  -124,
    -854,  -854,  -854,  1116,  -854,  -854,   884,  1301,  -854,   719,
     889,   713,   874,   813,  -854,  -854,  -854,  -854,  -854,  -147,
    -854,  1149,  -854,  -624,  -575,  -448,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -547,  -854,  -854,  -854,
    -854,  -854,  -499,  -854,  -566,  -854,   552,  -576,  -854,  -853,
     573,  -475,   -24,  -490,   578,  -854,  -556,  -544,  -522,  -486,
    -854,  -854,   549,  -854,   693,  -854,   867,  -580
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   323,   501,   324,   309,   725,   718,   705,
     326,   310,   327,   328,   636,   562,   563,   311,   494,   736,
     566,   650,   509,   578,   579,   651,   467,   118,   119,   652,
     330,   331,   332,   653,   687,   543,   680,   238,   240,   242,
     244,   246,   248,   250,   252,   254,   661,   758,   759,   760,
     761,   762,   531,   663,   707,   615,   708,   532,   666,   854,
     846,   533,   912,   534,   855,   856,   535,   536,   537,   538,
     906,   907,   908,   945,   699,   844,   691,   539
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     265,   325,   545,   329,   668,   274,   439,   548,   665,   549,
     738,   550,   288,   290,   292,   668,   588,   668,   664,   665,
     727,   665,   733,   620,   737,   689,   474,   544,   667,   664,
     546,   664,   547,   193,   678,   709,   154,   156,   398,   667,
     551,   667,   552,   619,   722,   589,   481,   471,   682,   479,
     684,   720,   366,   368,   370,   619,   726,   487,   619,   619,
     619,   528,   483,   771,   950,   489,   499,   329,   730,   315,
     591,   120,   772,   485,   507,   593,   668,   668,   603,   709,
     665,   665,   959,   960,   530,   662,   784,   672,   299,   255,
     664,   664,   723,   500,   693,   681,   662,   683,   662,   685,
     667,   667,   508,   915,   401,   698,   406,   190,   821,   742,
     743,   975,   275,   303,   777,   724,   706,   301,   778,   121,
     787,   305,   709,   307,   709,   122,  -371,  -371,   986,   788,
     262,   263,   747,   748,   834,   793,   437,   357,   264,   816,
     476,   361,   528,   257,   794,   644,   679,   234,   586,   389,
    -371,   391,   393,   457,   123,   749,   459,   662,   662,   508,
     706,   312,   836,   528,   564,   530,   124,   668,   668,   676,
     259,   665,   665,   450,   125,   155,   157,   239,   325,   823,
     329,   664,   664,   745,   421,   673,   530,   423,   824,   465,
     739,   667,   667,   569,   740,   860,   237,   792,   894,   853,
     830,   831,   895,   706,   621,   706,   540,   863,   541,   542,
     528,   475,   399,   400,   241,   194,   723,   709,   709,   709,
     709,   709,   709,   709,   709,   709,   709,   590,   723,   482,
     472,   857,   473,   530,   480,   807,   808,   809,   810,   724,
     812,   316,   488,   317,   318,   484,   319,   320,   662,   662,
     490,   724,   592,   858,   321,   619,   486,   594,   262,   263,
     604,   256,   300,   837,   322,   694,   264,   928,   785,   695,
     528,   929,   860,   843,   696,   266,   853,   861,   402,   403,
     407,   408,   191,   847,   916,   554,   698,   276,   304,   859,
     568,   302,   864,   530,   571,   871,   306,   308,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   857,   958,
     438,   318,   358,   319,   320,   258,   362,   619,   619,   619,
     619,   321,   619,   477,   390,   478,   392,   394,   458,   668,
     858,   460,   860,   665,   967,   308,   853,   860,   867,   565,
     868,   853,   260,   664,   677,   451,   329,   452,   635,   262,
     263,   329,   126,   667,   268,   329,   270,   264,   422,   158,
     674,   424,   946,   466,   262,   263,   859,   -30,   857,   127,
     903,   272,   264,   857,   277,   279,   281,   283,   285,   128,
     261,   860,   860,   860,   860,   853,   853,   853,   853,   295,
     858,   587,   860,   860,   860,   858,   853,   853,   853,   262,
     263,   860,   937,   905,   943,   853,   670,   264,   297,   329,
     662,   528,   926,   619,   847,   333,   129,   857,   857,   857,
     857,   747,   748,   892,   335,   337,   859,   287,   857,   857,
     857,   859,   893,   130,   530,   773,   619,   857,   131,   858,
     858,   858,   858,   345,   347,   349,   351,   267,   289,   779,
     858,   858,   858,   780,   132,   353,   262,   263,   355,   858,
     660,   783,   671,   865,   264,   780,   675,   695,   528,   291,
     359,   660,   696,   660,   365,   859,   859,   859,   859,   367,
     697,   363,   371,   373,   375,   369,   859,   859,   859,   133,
     377,   530,   379,   381,   383,   859,   747,   748,   159,   735,
     385,   947,   387,   512,   513,   514,   515,   516,   517,   518,
     775,   396,   404,   160,   409,   411,   413,   415,   849,   729,
     520,  -461,  -461,   850,   521,   522,   269,   417,   271,   419,
     523,   524,   660,   660,   947,   134,   512,   513,   514,   515,
     516,   517,   518,   273,   262,   263,   278,   280,   282,   284,
     286,   849,   264,   520,  -459,  -459,   850,   521,   522,   425,
     427,   296,   429,   523,   524,   162,   431,   433,   435,   440,
     442,   947,   791,   512,   513,   514,   515,   516,   517,   518,
     298,   444,   446,   735,   448,   461,   463,   334,   849,   468,
     520,   262,   263,   850,   521,   522,   336,   338,   135,   264,
     523,   524,   617,   716,   512,   513,   514,   515,   516,   517,
     518,   164,   262,   263,   136,   346,   348,   350,   352,   519,
     264,   520,   247,   660,   660,   521,   522,   354,   719,   221,
     356,   523,   524,   262,   263,   525,   526,   835,   262,   263,
     815,   264,   360,   262,   263,   223,   264,   137,   842,   262,
     263,   264,   161,   364,   372,   374,   376,   264,   900,   817,
     138,   697,   378,   778,   380,   382,   384,   901,   525,   526,
     870,   833,   386,   575,   388,   527,   819,   528,   576,   577,
     780,   139,   851,   397,   405,  -461,   410,   412,   414,   416,
     947,   243,   512,   513,   514,   515,   516,   517,   518,   418,
     530,   420,   921,   245,   163,   525,   526,   849,   527,   520,
     528,   794,   850,   521,   522,   851,   262,   263,  -459,   523,
     524,   747,   748,   540,   264,   541,   542,   790,   528,   747,
     748,   426,   428,   530,   430,   827,   525,   526,   432,   434,
     436,   441,   443,   964,   918,   527,   249,   528,   778,   140,
     165,   530,   851,   445,   447,   948,   449,   462,   464,   141,
     -75,   469,   438,   318,   142,   319,   320,   251,   222,   143,
     530,   262,   263,   321,   144,   717,   527,   936,   528,   264,
     145,   941,   728,   529,   224,   660,   618,   617,   146,   512,
     513,   514,   515,   516,   517,   518,   147,   262,   263,   148,
     717,   530,   149,   150,   519,   264,   520,   555,   940,   919,
     521,   522,   717,   780,   151,   152,   523,   524,  -370,  -370,
     319,   320,   647,   153,   525,   526,   253,   166,   321,   293,
     617,   294,   512,   513,   514,   515,   516,   517,   518,   167,
     308,   840,  -370,   319,   320,   647,   168,   519,   781,   520,
     169,   321,   778,   521,   522,   934,   922,   782,   924,   523,
     524,   734,   170,   930,   527,   923,   528,   925,   171,   172,
     173,   851,   931,   617,  -463,   512,   513,   514,   515,   516,
     517,   518,   174,   314,   -75,   -75,   -75,   339,   175,   530,
     519,   646,   520,   -75,   -75,   -75,   521,   522,   176,   319,
     320,   647,   523,   524,   648,   177,   617,   321,   512,   513,
     514,   515,   516,   517,   518,   178,   179,   955,   968,   976,
     180,   525,   526,   519,   181,   520,   956,   969,   977,   521,
     522,   556,   557,   558,   182,   523,   524,   972,   973,   974,
     559,   560,   561,   617,   183,   512,   513,   514,   515,   516,
     517,   518,   750,   751,   752,   753,   754,   755,   756,   757,
     519,   527,   520,   528,   525,   526,   521,   522,   529,   395,
     184,   624,   523,   524,   319,   320,   647,   262,   263,   732,
     185,   186,   321,   187,   188,   264,   530,   553,   841,   528,
     189,   262,   263,   192,   438,   318,   195,   319,   320,   264,
     196,   197,   935,   528,   527,   321,   528,   525,   526,   198,
     199,   529,   530,   617,   627,   512,   513,   514,   515,   516,
     517,   518,   200,   262,   263,   201,   530,   202,   203,   530,
     519,   264,   520,   204,   869,   528,   521,   522,   205,   455,
     525,   526,   523,   524,   319,   320,   647,   527,   206,   528,
     207,   208,   321,   209,   529,   210,   211,   628,   530,   797,
     798,   799,   800,   801,   802,   803,   804,   805,   806,   212,
     213,   214,   530,   215,   216,   340,   217,   525,   526,   218,
     527,   219,   528,   220,   225,   226,   829,   529,   227,   228,
     629,   617,   229,   512,   513,   514,   515,   516,   517,   518,
     802,   803,   804,   805,   806,   530,   230,   231,   519,   232,
     520,   233,   493,   341,   521,   522,   495,   527,   496,   528,
     523,   524,   -35,   342,   529,   319,   617,   828,   512,   513,
     514,   515,   516,   517,   518,   343,   344,   453,   454,   505,
     567,   456,   530,   519,   646,   520,   470,   525,   526,   521,
     522,   491,   319,   320,   647,   523,   524,   648,   492,   649,
     321,   617,   504,   512,   513,   514,   515,   516,   517,   518,
     316,   498,   317,   318,   502,   319,   320,   506,   519,   511,
     520,   510,   570,   321,   521,   522,   572,   527,   574,   528,
     523,   524,   573,   322,   529,   581,   582,   883,   617,   580,
     512,   513,   514,   515,   516,   517,   518,   583,   584,   585,
     595,   746,   530,   596,   597,   519,   598,   520,   599,   600,
     601,   521,   522,   602,   616,   525,   526,   523,   524,   617,
     622,   512,   513,   514,   515,   516,   517,   518,   623,   625,
     626,   630,   631,   632,   633,   634,   519,   637,   520,   565,
     638,   641,   521,   522,   795,   655,   796,   642,   523,   524,
     525,   526,   643,   669,   654,   527,   700,   528,   686,   688,
     690,   701,   529,   710,   617,   884,   512,   513,   514,   515,
     516,   517,   518,   711,   712,   713,   714,   715,   741,   721,
     530,   519,   763,   520,   764,   525,   526,   521,   522,   765,
     527,   766,   528,   523,   524,   767,   768,   529,   770,   769,
     885,   774,   512,   513,   514,   515,   516,   517,   518,   776,
     789,   786,   811,   813,   814,   530,   818,   519,   822,   832,
     826,   838,   525,   526,   839,   527,   848,   528,   862,   523,
     524,   889,   529,   887,   890,   886,   891,   896,   897,   873,
     874,   875,   876,   877,   878,   879,   880,   881,   882,   898,
     530,   899,   904,   525,   526,   905,   909,   910,   914,   927,
     917,   920,   527,   932,   528,   605,   942,   933,   951,   529,
     970,   954,   888,   952,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   957,   965,   961,   966,   530,   971,   978,
     979,   962,   981,   527,   963,   528,   982,   985,   525,   526,
     529,   983,   980,   938,   512,   513,   514,   515,   516,   517,
     518,   984,   987,   989,   988,   990,   991,   992,   530,   849,
     913,   520,   993,   994,   850,   521,   522,   995,   997,   236,
     996,   523,   524,   503,   525,   526,   639,   998,   527,   313,
     528,   820,   825,   645,   640,   529,   944,   731,   953,   797,
     798,   799,   800,   801,   802,   803,   804,   805,   806,   692,
     497,   872,     0,   530,   262,   263,     0,   939,   866,   656,
       0,     0,   264,     0,   527,     0,   528,     0,     0,     0,
     949,     0,   657,   658,     0,   659,   512,   513,   514,   515,
     516,   517,   518,     0,     0,     0,     0,     0,     0,   530,
       0,   849,     0,   520,     0,     0,   850,   521,   522,     0,
       0,     0,     0,   523,   524,     0,   512,   513,   514,   515,
     516,   517,   518,     0,     0,     0,     0,     0,     0,   913,
     913,   913,     0,     0,     0,     0,   525,   526,     0,     0,
     949,   949,   949,   523,   524,   797,   798,   799,   800,   801,
     802,   803,   804,   805,   806,     0,     0,     0,     0,     0,
     512,   513,   514,   515,   516,   517,   518,     0,     0,     0,
       0,     0,     0,     0,     0,   519,   527,   520,   528,     0,
       0,   521,   522,   851,     0,   852,     0,   523,   524,   512,
     513,   514,   515,   516,   517,   518,     0,     0,     0,     0,
       0,   530,     0,     0,   519,     0,   520,     0,     0,     0,
     521,   522,     0,     0,     0,     0,   523,   524,   525,   526,
       0,     0,     0,   512,   513,   514,   515,   516,   517,   518,
       0,     0,     0,     0,     0,     0,     0,     0,   519,     0,
     520,     0,     0,     0,   521,   522,     0,     0,   525,   526,
     523,   524,     0,     0,     0,     0,     0,     0,   527,     0,
     528,     0,     0,     0,     0,   851,     0,     0,   911,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   262,   263,
       0,     0,     0,   530,   702,     0,   264,     0,   527,   703,
     528,     0,   525,   526,     0,     0,   704,   512,   513,   514,
     515,   516,   517,   518,     0,     0,     0,     0,     0,     0,
       0,     0,   849,   530,   520,     0,     0,   850,   521,   522,
       0,   525,   526,     0,   523,   524,     0,     0,     0,     0,
       0,     0,   527,     0,   528,     0,     0,     0,     0,   529,
       0,     0,   744,     0,     0,   512,   513,   514,   515,   516,
     517,   518,     0,     0,     0,   525,   526,   530,     0,     0,
     519,   527,   520,   528,     0,     0,   521,   522,   529,     0,
     845,     0,   523,   524,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   530,     0,     0,     0,
       0,     0,     0,     0,     0,   527,     0,   528,     0,     0,
       0,     0,   529,     0,     0,   902,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     530,     0,     0,     0,     0,     0,     0,     0,     0,   525,
     526,   605,   750,   751,   752,   753,   754,   755,   756,   757,
     606,   607,   608,   609,   610,   611,   612,   613,   614,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   527,
       0,   528,     0,     0,     0,     0,   851,   525,   526,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   530,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   527,     0,   528,
      -2,   235,     0,     0,   529,     0,     0,     0,     0,    -8,
     -10,   -12,   -14,   -16,   -18,   -20,   -22,   -24,     0,     0,
       0,     0,   530,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,     0,    28,
      29,    30,    31,    32,     0,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,     0,     0,     0,   102,   103,   104,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     1,     0,     0,     0,     0,     0,
       0,     0,    -8,   -10,   -12,   -14,   -16,   -18,   -20,   -22,
     -24,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   105,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     0,    28,    29,    30,    31,    32,     0,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,     0,     0,     0,
     102,   103,   104,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   105
};

static const yytype_int16 yycheck[] =
{
     124,   150,   477,   150,   584,   129,   214,   482,   584,   484,
       1,   486,   136,   137,   138,   595,   515,   597,   584,   595,
     642,   597,   646,     1,   648,   600,     1,   475,   584,   595,
     478,   597,   480,     1,     1,   615,     1,     1,     1,   595,
     488,   597,   490,   533,     1,     1,     1,     1,   595,     1,
     597,   633,   176,   177,   178,   545,     1,     1,   548,   549,
     550,   177,     1,   172,   917,     1,   166,   214,   643,     1,
       1,   140,   181,     1,   167,     1,   656,   657,     1,   659,
     656,   657,   204,   205,   200,   584,     1,   586,     1,     1,
     656,   657,   173,   193,     1,   594,   595,   596,   597,   598,
     656,   657,   195,     1,     1,   604,     1,     1,   732,   656,
     657,   964,     1,     1,   172,   196,   615,     1,   176,   140,
     172,     1,   702,     1,   704,   140,   176,   177,   981,   181,
     165,   166,   158,   159,   758,   172,     1,     1,   173,   721,
       1,     1,   177,     1,   181,   181,   594,     0,   183,     1,
     200,     1,     1,     1,   140,   181,     1,   656,   657,   195,
     659,     1,   176,   177,     1,   200,   140,   747,   748,     1,
       1,   747,   748,     1,   140,   140,   140,    10,   327,   172,
     327,   747,   748,   658,     1,     1,   200,     1,   181,     1,
     181,   747,   748,     1,   185,   775,     9,   696,   822,   775,
     747,   748,   824,   702,   182,   704,   173,   782,   175,   176,
     177,   186,   175,   176,    11,   183,   173,   797,   798,   799,
     800,   801,   802,   803,   804,   805,   806,   183,   173,   184,
     184,   775,   186,   200,   186,   710,   711,   712,   713,   196,
     715,   173,   186,   175,   176,   184,   178,   179,   747,   748,
     186,   196,   183,   775,   186,   745,   184,   183,   165,   166,
     183,   173,   175,   762,   196,   172,   173,   891,   183,   176,
     177,   893,   852,   772,   181,     1,   852,   776,   175,   176,
     175,   176,   176,   773,   182,   493,   785,   176,   176,   775,
     498,   175,     1,   200,   502,   794,   176,   175,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   852,   931,
     175,   176,   176,   178,   179,   173,   176,   807,   808,   809,
     810,   186,   812,   184,   176,   186,   176,   176,   176,   909,
     852,   176,   912,   909,   956,   175,   912,   917,   786,   176,
     788,   917,   173,   909,   176,   173,   493,   175,   556,   165,
     166,   498,   140,   909,     1,   502,     1,   173,   175,     1,
     176,   175,   909,   175,   165,   166,   852,   175,   912,   140,
     845,     1,   173,   917,     1,     1,     1,     1,     1,   140,
       1,   961,   962,   963,   964,   961,   962,   963,   964,     1,
     912,   515,   972,   973,   974,   917,   972,   973,   974,   165,
     166,   981,   901,    21,    22,   981,   172,   173,     1,   556,
     909,   177,   887,   903,   904,     1,   140,   961,   962,   963,
     964,   158,   159,   172,     1,     1,   912,     1,   972,   973,
     974,   917,   181,   140,   200,   172,   926,   981,   140,   961,
     962,   963,   964,     1,     1,     1,     1,   173,     1,   172,
     972,   973,   974,   176,   140,     1,   165,   166,     1,   981,
     584,   172,   586,   172,   173,   176,   590,   176,   177,     1,
       1,   595,   181,   597,     1,   961,   962,   963,   964,     1,
     604,     1,     1,     1,     1,     1,   972,   973,   974,   140,
       1,   200,     1,     1,     1,   981,   158,   159,   140,   648,
       1,     1,     1,     3,     4,     5,     6,     7,     8,     9,
     172,     1,     1,     1,     1,     1,     1,     1,    18,   643,
      20,    21,    22,    23,    24,    25,   173,     1,   173,     1,
      30,    31,   656,   657,     1,   140,     3,     4,     5,     6,
       7,     8,     9,   173,   165,   166,   173,   173,   173,   173,
     173,    18,   173,    20,    21,    22,    23,    24,    25,     1,
       1,   173,     1,    30,    31,     1,     1,     1,     1,     1,
       1,     1,   696,     3,     4,     5,     6,     7,     8,     9,
     173,     1,     1,   732,     1,     1,     1,   173,    18,     1,
      20,   165,   166,    23,    24,    25,   173,   173,   140,   173,
      30,    31,     1,     1,     3,     4,     5,     6,     7,     8,
       9,     1,   165,   166,   140,   173,   173,   173,   173,    18,
     173,    20,    14,   747,   748,    24,    25,   173,     1,     1,
     173,    30,    31,   165,   166,   135,   136,   761,   165,   166,
       1,   173,   173,   165,   166,     1,   173,   140,   772,   165,
     166,   173,   140,   173,   173,   173,   173,   173,   172,   172,
     140,   785,   173,   176,   173,   173,   173,   181,   135,   136,
     794,    29,   173,    22,   173,   175,   172,   177,    27,    28,
     176,   140,   182,   173,   173,   185,   173,   173,   173,   173,
       1,    12,     3,     4,     5,     6,     7,     8,     9,   173,
     200,   173,   172,    13,   140,   135,   136,    18,   175,    20,
     177,   181,    23,    24,    25,   182,   165,   166,   185,    30,
      31,   158,   159,   173,   173,   175,   176,   176,   177,   158,
     159,   173,   173,   200,   173,   172,   135,   136,   173,   173,
     173,   173,   173,   172,   172,   175,    15,   177,   176,   140,
     140,   200,   182,   173,   173,   185,   173,   173,   173,   140,
      64,   173,   175,   176,   140,   178,   179,    16,   140,   140,
     200,   165,   166,   186,   140,   173,   175,   901,   177,   173,
     140,   905,   176,   182,   140,   909,   185,     1,   140,     3,
       4,     5,     6,     7,     8,     9,   140,   165,   166,   140,
     173,   200,   140,   140,    18,   173,    20,    64,   176,   172,
      24,    25,   173,   176,   140,   140,    30,    31,   176,   177,
     178,   179,   180,   140,   135,   136,    17,   140,   186,   176,
       1,   176,     3,     4,     5,     6,     7,     8,     9,   140,
     175,    29,   200,   178,   179,   180,   140,    18,   172,    20,
     140,   186,   176,    24,    25,    29,   172,   181,   172,    30,
      31,   196,   140,   172,   175,   181,   177,   181,   140,   140,
     140,   182,   181,     1,   185,     3,     4,     5,     6,     7,
       8,     9,   140,   176,   188,   189,   190,   173,   140,   200,
      18,   170,    20,   197,   198,   199,    24,    25,   140,   178,
     179,   180,    30,    31,   183,   140,     1,   186,     3,     4,
       5,     6,     7,     8,     9,   140,   140,   172,   172,   172,
     140,   135,   136,    18,   140,    20,   181,   181,   181,    24,
      25,   188,   189,   190,   140,    30,    31,   961,   962,   963,
     197,   198,   199,     1,   140,     3,     4,     5,     6,     7,
       8,     9,   141,   142,   143,   144,   145,   146,   147,   148,
      18,   175,    20,   177,   135,   136,    24,    25,   182,   176,
     140,   185,    30,    31,   178,   179,   180,   165,   166,   183,
     140,   140,   186,   140,   140,   173,   200,   168,   176,   177,
     140,   165,   166,   140,   175,   176,   140,   178,   179,   173,
     140,   140,   176,   177,   175,   186,   177,   135,   136,   140,
     140,   182,   200,     1,   185,     3,     4,     5,     6,     7,
       8,     9,   140,   165,   166,   140,   200,   140,   140,   200,
      18,   173,    20,   140,   176,   177,    24,    25,   140,   175,
     135,   136,    30,    31,   178,   179,   180,   175,   140,   177,
     140,   140,   186,   140,   182,   140,   140,   185,   200,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   140,
     140,   140,   200,   140,   140,   173,   140,   135,   136,   140,
     175,   140,   177,   140,   140,   140,   187,   182,   140,   140,
     185,     1,   140,     3,     4,     5,     6,     7,     8,     9,
     165,   166,   167,   168,   169,   200,   140,   140,    18,   140,
      20,   140,   195,   173,    24,    25,   195,   175,     1,   177,
      30,    31,   195,   173,   182,   178,     1,   185,     3,     4,
       5,     6,     7,     8,     9,   173,   173,   173,   173,   181,
     187,   173,   200,    18,   170,    20,   173,   135,   136,    24,
      25,   173,   178,   179,   180,    30,    31,   183,   173,   185,
     186,     1,   190,     3,     4,     5,     6,     7,     8,     9,
     173,   195,   175,   176,   195,   178,   179,   190,    18,   190,
      20,   201,   175,   186,    24,    25,   175,   175,   175,   177,
      30,    31,   176,   196,   182,   173,   175,   185,     1,   184,
       3,     4,     5,     6,     7,     8,     9,   183,   183,   183,
     183,   659,   200,   183,   183,    18,   183,    20,   183,   183,
     183,    24,    25,   183,   182,   135,   136,    30,    31,     1,
     187,     3,     4,     5,     6,     7,     8,     9,   187,   187,
     187,   181,   187,   195,   195,   175,    18,   173,    20,   176,
     175,   195,    24,    25,   702,   172,   704,   195,    30,    31,
     135,   136,   181,   172,   203,   175,    29,   177,   176,   176,
     175,    29,   182,   184,     1,   185,     3,     4,     5,     6,
       7,     8,     9,   184,   184,   184,   173,   184,   173,   195,
     200,    18,   172,    20,   172,   135,   136,    24,    25,   172,
     175,   172,   177,    30,    31,   181,   172,   182,   172,   181,
     185,   172,     3,     4,     5,     6,     7,     8,     9,    26,
     172,   181,   187,   166,   181,   200,   172,    18,   181,   176,
     169,   176,   135,   136,   176,   175,   184,   177,   176,    30,
      31,   173,   182,   184,   173,   185,   181,    25,   172,   797,
     798,   799,   800,   801,   802,   803,   804,   805,   806,   172,
     200,   172,    19,   135,   136,    21,   183,   182,   182,   166,
     172,   172,   175,   172,   177,   140,   185,   173,   173,   182,
     202,   173,   185,   176,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   172,   172,   195,   172,   200,   173,   176,
     173,   195,    19,   175,   195,   177,   176,   173,   135,   136,
     182,   172,   202,   185,     3,     4,     5,     6,     7,     8,
       9,   203,   172,   203,   173,   169,   173,    25,   200,    18,
     852,    20,   169,   173,    23,    24,    25,    25,   173,   107,
     204,    30,    31,   327,   135,   136,   562,   204,   175,   148,
     177,   732,   739,   579,   565,   182,   907,   644,   185,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   602,
     321,   172,    -1,   200,   165,   166,    -1,   904,   785,   170,
      -1,    -1,   173,    -1,   175,    -1,   177,    -1,    -1,    -1,
     912,    -1,   183,   184,    -1,   186,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,   200,
      -1,    18,    -1,    20,    -1,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    31,    -1,     3,     4,     5,     6,
       7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,   961,
     962,   963,    -1,    -1,    -1,    -1,   135,   136,    -1,    -1,
     972,   973,   974,    30,    31,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    18,   175,    20,   177,    -1,
      -1,    24,    25,   182,    -1,   184,    -1,    30,    31,     3,
       4,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      -1,   200,    -1,    -1,    18,    -1,    20,    -1,    -1,    -1,
      24,    25,    -1,    -1,    -1,    -1,    30,    31,   135,   136,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    -1,
      20,    -1,    -1,    -1,    24,    25,    -1,    -1,   135,   136,
      30,    31,    -1,    -1,    -1,    -1,    -1,    -1,   175,    -1,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,   185,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   165,   166,
      -1,    -1,    -1,   200,   171,    -1,   173,    -1,   175,   176,
     177,    -1,   135,   136,    -1,    -1,   183,     3,     4,     5,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    18,   200,    20,    -1,    -1,    23,    24,    25,
      -1,   135,   136,    -1,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,   175,    -1,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,   185,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    -1,    -1,    -1,   135,   136,   200,    -1,    -1,
      18,   175,    20,   177,    -1,    -1,    24,    25,   182,    -1,
     184,    -1,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   175,    -1,   177,    -1,    -1,
      -1,    -1,   182,    -1,    -1,   185,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,
     136,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,
      -1,   177,    -1,    -1,    -1,    -1,   182,   135,   136,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   200,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,    -1,   177,
       0,     1,    -1,    -1,   182,    -1,    -1,    -1,    -1,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    -1,
      -1,    -1,   200,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    -1,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,    -1,    -1,    -1,   137,   138,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    -1,    59,    60,    61,    62,    63,    -1,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,    -1,    -1,    -1,
     137,   138,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   194
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    59,    60,
      61,    62,    63,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   137,   138,   139,   194,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   244,   245,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,     1,   140,     1,   140,     1,   140,
       1,   140,     1,   140,     1,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
       1,   176,   140,     1,   183,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,     1,   140,     1,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,     0,     1,   210,     9,   254,    10,
     255,    11,   256,    12,   257,    13,   258,    14,   259,    15,
     260,    16,   261,    17,   262,     1,   173,     1,   173,     1,
     173,     1,   165,   166,   173,   226,     1,   173,     1,   173,
       1,   173,     1,   173,   226,     1,   176,     1,   173,     1,
     173,     1,   173,     1,   173,     1,   173,     1,   226,     1,
     226,     1,   226,   176,   176,     1,   173,     1,   173,     1,
     175,     1,   175,     1,   176,     1,   176,     1,   175,   223,
     228,   234,     1,   234,   176,     1,   173,   175,   176,   178,
     179,   186,   196,   220,   222,   223,   227,   229,   230,   246,
     247,   248,   249,     1,   173,     1,   173,     1,   173,   173,
     173,   173,   173,   173,   173,     1,   173,     1,   173,     1,
     173,     1,   173,     1,   173,     1,   173,     1,   176,     1,
     173,     1,   176,     1,   173,     1,   226,     1,   226,     1,
     226,     1,   173,     1,   173,     1,   173,     1,   173,     1,
     173,     1,   173,     1,   173,     1,   173,     1,   173,     1,
     176,     1,   176,     1,   176,   176,     1,   173,     1,   175,
     176,     1,   175,   176,     1,   173,     1,   175,   176,     1,
     173,     1,   173,     1,   173,     1,   173,     1,   173,     1,
     173,     1,   175,     1,   175,     1,   173,     1,   173,     1,
     173,     1,   173,     1,   173,     1,   173,     1,   175,   220,
       1,   173,     1,   173,     1,   173,     1,   173,     1,   173,
       1,   173,   175,   173,   173,   175,   173,     1,   176,     1,
     176,     1,   173,     1,   173,     1,   175,   243,     1,   173,
     173,     1,   184,   186,     1,   186,     1,   184,   186,     1,
     186,     1,   184,     1,   184,     1,   184,     1,   186,     1,
     186,   173,   173,   195,   235,   195,     1,   248,   195,   166,
     193,   221,   195,   230,   190,   181,   190,   167,   195,   239,
     201,   190,     3,     4,     5,     6,     7,     8,     9,    18,
      20,    24,    25,    30,    31,   135,   136,   175,   177,   182,
     200,   269,   274,   278,   280,   283,   284,   285,   286,   294,
     173,   175,   176,   252,   252,   278,   252,   252,   278,   278,
     278,   252,   252,   168,   220,    64,   188,   189,   190,   197,
     198,   199,   232,   233,     1,   176,   237,   187,   220,     1,
     175,   220,   175,   176,   175,    22,    27,    28,   240,   241,
     184,   173,   175,   183,   183,   183,   183,   226,   269,     1,
     183,     1,   183,     1,   183,   183,   183,   183,   183,   183,
     183,   183,   183,     1,   183,   140,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   272,   182,     1,   185,   280,
       1,   182,   187,   187,   185,   187,   187,   185,   185,   185,
     181,   187,   195,   195,   175,   220,   231,   173,   175,   233,
     237,   195,   195,   181,   181,   239,   170,   180,   183,   185,
     238,   242,   246,   250,   203,   172,   170,   183,   184,   186,
     226,   263,   269,   270,   271,   274,   275,   283,   294,   172,
     172,   226,   269,     1,   176,   226,     1,   176,     1,   252,
     253,   269,   263,   269,   263,   269,   176,   251,   176,   251,
     175,   293,   293,     1,   172,   176,   181,   226,   269,   291,
      29,    29,   171,   176,   183,   226,   269,   271,   273,   294,
     184,   184,   184,   184,   173,   184,     1,   173,   225,     1,
     225,   195,     1,   173,   196,   224,     1,   224,   176,   226,
     251,   240,   183,   250,   196,   223,   236,   250,     1,   181,
     185,   173,   263,   263,   185,   278,   273,   158,   159,   181,
     141,   142,   143,   144,   145,   146,   147,   148,   264,   265,
     266,   267,   268,   172,   172,   172,   172,   181,   172,   181,
     172,   172,   181,   172,   172,   172,    26,   172,   176,   172,
     176,   172,   181,   172,     1,   183,   181,   172,   181,   172,
     176,   226,   269,   172,   181,   273,   273,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   278,   278,   278,
     278,   187,   278,   166,   181,     1,   225,   172,   172,   172,
     236,   250,   181,   172,   181,   238,   169,   172,   185,   187,
     263,   263,   176,    29,   250,   226,   176,   269,   176,   176,
      29,   176,   226,   269,   292,   184,   277,   280,   184,    18,
      23,   182,   184,   274,   276,   281,   282,   284,   285,   286,
     294,   269,   176,   251,     1,   172,   291,   252,   252,   176,
     226,   269,   172,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   185,   185,   185,   185,   184,   185,   173,
     173,   181,   172,   181,   250,   224,    25,   172,   172,   172,
     172,   181,   185,   278,    19,    21,   287,   288,   289,   183,
     182,   185,   279,   281,   182,     1,   182,   172,   172,   172,
     172,   172,   172,   181,   172,   181,   278,   166,   250,   224,
     172,   181,   172,   173,    29,   176,   226,   269,   185,   277,
     176,   226,   185,    22,   289,   290,   263,     1,   185,   281,
     276,   173,   176,   185,   173,   172,   181,   172,   224,   204,
     205,   195,   195,   195,   172,   172,   172,   224,   172,   181,
     202,   173,   279,   279,   279,   276,   172,   181,   176,   173,
     202,    19,   176,   172,   203,   173,   276,   172,   173,   203,
     169,   173,    25,   169,   173,    25,   204,   173,   204
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   207,   208,   209,   209,   209,   210,   210,   211,   210,
     212,   210,   213,   210,   214,   210,   215,   210,   216,   210,
     217,   210,   218,   210,   219,   210,   210,   220,   220,   220,
     221,   221,   222,   222,   222,   223,   224,   224,   225,   225,
     225,   225,   226,   226,   226,   227,   227,   227,   227,   228,
     228,   228,   228,   228,   228,   229,   229,   229,   229,   229,
     230,   230,   231,   231,   231,   232,   232,   232,   232,   232,
     232,   232,   233,   233,   234,   235,   234,   236,   236,   237,
     237,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   239,   239,   239,   240,   240,   240,   241,
     241,   242,   242,   242,   243,   243,   243,   243,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   244,   244,   244,   244,   244,   244,   244,
     244,   244,   244,   245,   245,   245,   245,   245,   245,   246,
     246,   247,   248,   249,   249,   250,   250,   251,   251,   252,
     252,   252,   253,   253,   254,   254,   254,   255,   255,   256,
     256,   256,   257,   257,   258,   258,   259,   259,   260,   260,
     261,   261,   262,   262,   263,   263,   263,   263,   263,   263,
     264,   264,   265,   265,   265,   265,   266,   266,   267,   267,
     268,   268,   268,   269,   269,   270,   270,   270,   270,   271,
     271,   271,   271,   271,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   274,   274,   274,   275,   275,   275,   275,   275,   276,
     276,   276,   277,   277,   277,   278,   278,   278,   279,   279,
     279,   280,   280,   280,   280,   280,   280,   280,   280,   281,
     281,   281,   281,   281,   281,   281,   281,   281,   282,   282,
     283,   283,   284,   285,   286,   287,   287,   288,   288,   289,
     289,   289,   289,   290,   290,   291,   291,   291,   291,   291,
     291,   291,   291,   291,   291,   291,   292,   292,   292,   292,
     292,   292,   292,   292,   293,   293,   293,   293,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     1,     1,     1,     5,     3,
       3,     1,     1,     2,     2,     3,     5,     5,     2,     3,
       3,     5,     5,     5,     5,     1,     3,     5,     5,     1,
       1,     2,     1,     3,     3,     1,     1,     1,     2,     2,
       2,     2,     1,     2,     1,     0,     3,     1,     1,     1,
       2,     9,    10,     7,     8,     5,     6,     5,     6,     3,
       4,     1,     2,     4,     3,     0,     1,     1,     1,     3,
       1,     3,     1,     2,    18,    17,    10,     9,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     3,     3,     3,     3,     5,     3,
       3,     5,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     5,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       5,     5,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     2,     6,     4,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     2,     8,     8,     8,     2,     1,
       1,     1,     1,     1,     3,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     4,     7,     2,     7,     2,     4,
       7,     2,     7,     2,     4,     2,     4,     2,     4,     2,
       9,     2,     7,     2,     3,     3,     2,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     3,     3,     3,     1,     1,     1,     3,     2,     1,
       3,     2,     1,     3,     2,     2,     1,     2,     2,     1,
       2,     2,     1,     1,     1,     1,     2,     1,     2,     2,
       2,     1,     1,     1,     1,     2,     1,     2,     5,     7,
       5,     7,     5,     7,     7,     2,     1,     2,     1,     4,
       3,     4,     3,     3,     2,     1,     3,     1,     2,     2,
       1,     2,     3,     1,     2,     3,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     4,     4,     2,     6,     1,
       3,     1,     3,     2,     4,     2,     4,     3,     1,     4,
       6,     2,     4,     6,     2,     4,     4,     6,     2,     4,
       3,     4,     4,     2,     4,     4,     4,     4,     6,     6,
       6,     8,     8,     6,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 513 "cfg.y" /* yacc.c:1646  */
    {}
#line 2594 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 514 "cfg.y" /* yacc.c:1646  */
    {}
#line 2600 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 515 "cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 2606 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 520 "cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 2612 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 521 "cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 2618 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 522 "cfg.y" /* yacc.c:1646  */
    {rt=ONREPLY_ROUTE;}
#line 2624 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 523 "cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 2630 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 524 "cfg.y" /* yacc.c:1646  */
    {rt=ERROR_ROUTE;}
#line 2636 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 525 "cfg.y" /* yacc.c:1646  */
    {rt=LOCAL_ROUTE;}
#line 2642 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 526 "cfg.y" /* yacc.c:1646  */
    {rt=STARTUP_ROUTE;}
#line 2648 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 527 "cfg.y" /* yacc.c:1646  */
    {rt=TIMER_ROUTE;}
#line 2654 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 528 "cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 2660 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 533 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							tmp=ip_addr2a((yyvsp[0].ipaddr));
							if(tmp==0){
								LM_CRIT("cfg. parser: bad ip address.\n");
								(yyval.strval)=0;
							}else{
								(yyval.strval)=pkg_malloc(strlen(tmp)+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), tmp, strlen(tmp)+1);
								}
							}
						}
#line 2680 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 548 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
							if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
							}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
							}
						}
#line 2694 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 557 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if ((yyvsp[0].strval)==0) {
								(yyval.strval) = 0;
							} else {
								(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
								if ((yyval.strval)==0){
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								}else{
									memcpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
								}
							}
						}
#line 2712 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 572 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)=".";}
#line 2718 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 573 "cfg.y" /* yacc.c:1646  */
    {(yyval.strval)="-"; }
#line 2724 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 576 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 2730 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 577 "cfg.y" /* yacc.c:1646  */
    { IFOR();
						(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
						if ((yyval.strval)==0){
							LM_CRIT("cfg. parser: memory allocation"
										" failure while parsing host\n");
							YYABORT;
						}else{
							memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))]=*(yyvsp[-1].strval);
							memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
							(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
						}
						pkg_free((yyvsp[-2].strval)); pkg_free((yyvsp[0].strval));
					}
#line 2749 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 591 "cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
					yyerror("invalid hostname (use quotes if hostname "
						"has config keywords)"); }
#line 2757 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 596 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		if (parse_proto((unsigned char *)(yyvsp[0].strval), strlen((yyvsp[0].strval)), &i_tmp) < 0) {
			yyerrorf("cannot handle protocol <%s>\n", (yyvsp[0].strval));
			YYABORT;
		}
		pkg_free((yyvsp[0].strval));
		(yyval.intval) = i_tmp;
	 }
#line 2770 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 606 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2776 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 607 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 2782 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 610 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if ((yyvsp[-2].intval) > (yyvsp[0].intval)) {
					yyerrorf("invalid port range (%d > %d)\n", (yyvsp[-2].intval), (yyvsp[0].intval));
					YYABORT;
				}
				pr_tmp = mk_port_range((yyvsp[-2].intval), (yyvsp[0].intval));
				if (!pr_tmp) {
					yyerror("cannot allocate new portrange\n");
					YYABORT;
				}
				pr_tmp->next = (yyvsp[-4].portrange);
				(yyval.portrange) = pr_tmp;
			}
#line 2800 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 623 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				pr_tmp = mk_port_range((yyvsp[0].intval), (yyvsp[0].intval));
				if (!pr_tmp) {
					yyerror("cannot allocate new portrange\n");
					YYABORT;
				}
				pr_tmp->next = (yyvsp[-2].portrange);
				(yyval.portrange) = pr_tmp;
			}
#line 2814 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 632 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if ((yyvsp[-2].intval) > (yyvsp[0].intval)) {
					yyerrorf("invalid port range (%d > %d)\n", (yyvsp[-2].intval), (yyvsp[0].intval));
					YYABORT;
				}
				(yyval.portrange)=mk_port_range((yyvsp[-2].intval), (yyvsp[0].intval));
			}
#line 2826 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 639 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.portrange)=mk_port_range((yyvsp[0].intval), (yyvsp[0].intval)); }
#line 2832 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 641 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2838 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 642 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 2844 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 643 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 2850 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 647 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2857 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 649 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 2864 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 651 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror("port number expected");
				YYABORT;
				}
#line 2874 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 656 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0;
				yyerror("protocol expected");
				YYABORT;
			}
#line 2883 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 664 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id(0, (yyvsp[-2].intval), 0); }
#line 2890 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 666 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id_range((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 2897 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 668 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id_range(0, (yyvsp[-4].intval), (yyvsp[0].portrange)); }
#line 2904 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 670 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id_range((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].portrange)); }
#line 2911 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 672 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=0;
				yyerror("invalid port range");
				YYABORT;
			}
#line 2921 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 677 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=0;
				yyerror("invalid port range");
				YYABORT;
			}
#line 2931 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 684 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2938 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 686 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2945 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 688 "cfg.y" /* yacc.c:1646  */
    { IFOR();
		 		(yyval.sockid)=mk_listen_id((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].intval)); }
#line 2952 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 690 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.sockid)=0;
				yyerror(" port number expected");
				}
#line 2961 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 697 "cfg.y" /* yacc.c:1646  */
    { IFOR();  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 2967 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 698 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.sockid)=(yyvsp[-1].sockid); (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 2973 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 701 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=mk_listen_id((yyvsp[0].strval), PROTO_NONE, 0); }
#line 2980 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 703 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=mk_listen_id_range((yyvsp[-2].strval), PROTO_NONE, (yyvsp[0].portrange)); }
#line 2987 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 705 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.sockid)=0;
					yyerror(" port number expected");
					}
#line 2996 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 711 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_IS_ANYCAST;
					}
#line 3004 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 714 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_FRAG;
					}
#line 3012 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 717 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.flags |= SI_REUSEPORT;
					}
#line 3020 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 720 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.workers=(yyvsp[0].intval);
					}
#line 3028 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 723 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.socket = (yyvsp[0].sockid);
					}
#line 3036 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 726 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.tag = (yyvsp[0].strval);
					}
#line 3044 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 729 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					p_tmp.auto_scaling_profile=(yyvsp[0].strval);
					}
#line 3052 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 738 "cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[0].sockid); }
#line 3058 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 739 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					memset(&p_tmp, 0, sizeof(p_tmp));
				}
#line 3066 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 741 "cfg.y" /* yacc.c:1646  */
    { IFOR();
					(yyval.sockid)=(yyvsp[-2].sockid); fill_socket_id(&p_tmp, (yyval.sockid));
				}
#line 3074 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 746 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_NONE; }
#line 3080 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 747 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 3086 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 749 "cfg.y" /* yacc.c:1646  */
    {  IFOR(); (yyval.multistr)=new_string((yyvsp[0].strval)); }
#line 3092 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 750 "cfg.y" /* yacc.c:1646  */
    { IFOR(); (yyval.multistr)=new_string((yyvsp[-1].strval)); (yyval.multistr)->next=(yyvsp[0].multistr); }
#line 3098 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 753 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,(yyvsp[-3].intval),(yyvsp[-7].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3111 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 761 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-5].ipnet)));
				s_tmp.s=(yyvsp[-1].strval);
				s_tmp.len=strlen((yyvsp[-1].strval));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-5].ipnet),&s_tmp,
				(yyvsp[-3].intval),(yyvsp[-7].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3125 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 770 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,(yyvsp[-1].intval),(yyvsp[-5].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3136 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 776 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,
				(yyvsp[-1].intval),(yyvsp[-5].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3148 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 783 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,0,(yyvsp[-3].intval),0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3159 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 789 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,
				0,(yyvsp[-3].intval),BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3171 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 796 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,(yyvsp[-1].intval),PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3182 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 802 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-3].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-3].ipnet),NULL,
				(yyvsp[-1].intval),PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3194 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 809 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,0,PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n"); YYABORT;
				}
			}
#line 3205 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 815 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[-1].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[-1].ipnet),NULL,
				0,PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3217 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 822 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[0].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[0].ipnet),NULL,0,PROTO_NONE,0)) {
					yyerror("failed to add backlist element\n"); YYABORT;
				}
			}
#line 3228 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 828 "cfg.y" /* yacc.c:1646  */
    {
				IFOR(pkg_free((yyvsp[0].ipnet)));
				if (add_rule_to_list(&bl_head,&bl_tail,(yyvsp[0].ipnet),NULL,
				0,PROTO_NONE,BLR_APPLY_CONTRARY)) {
					yyerror("failed to add backlist element\n");YYABORT;
				}
			}
#line 3240 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 842 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BL_READONLY_LIST; }
#line 3246 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 843 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BL_DO_EXPIRE; }
#line 3252 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 844 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BL_BY_DEFAULT; }
#line 3258 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 847 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval); }
#line 3264 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 848 "cfg.y" /* yacc.c:1646  */
    {}
#line 3270 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 851 "cfg.y" /* yacc.c:1646  */
    {}
#line 3276 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 852 "cfg.y" /* yacc.c:1646  */
    {}
#line 3282 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 853 "cfg.y" /* yacc.c:1646  */
    { yyerror("bad black list element");}
#line 3288 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 860 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-17].strval),(yyvsp[-15].intval),(yyvsp[-13].intval),(yyvsp[-10].intval),(yyvsp[-8].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval),10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3298 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 868 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-16].strval),(yyvsp[-14].intval),(yyvsp[-12].intval),(yyvsp[-9].intval),(yyvsp[-9].intval),
			(yyvsp[-6].intval), (yyvsp[-4].intval), (yyvsp[-1].intval), 10*(yyvsp[-1].intval))<0)
				yyerror("failed to create auto scaling profile");
		 }
#line 3308 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 874 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-9].strval),(yyvsp[-7].intval),(yyvsp[-5].intval),(yyvsp[-2].intval),(yyvsp[0].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3318 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 880 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (create_auto_scaling_profile((yyvsp[-8].strval),(yyvsp[-6].intval),(yyvsp[-4].intval),(yyvsp[-1].intval),(yyvsp[-1].intval),
			0, 0, 0, 0)<0)
				yyerror("failed to create auto scaling profile");
		}
#line 3328 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 887 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			/* in debug mode, force logging to DEBUG level*/
			*log_level = debug_mode?L_DBG:(yyvsp[0].intval);
			}
#line 3337 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 891 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (*(yyvsp[0].strval)) {
				int len = strlen((yyvsp[0].strval));
				char *buf = pkg_malloc(len + 2);
				if (!buf)
					yyerror("oom");
				sprintf(buf, "%s:", (yyvsp[0].strval));
				log_prefix = buf;
			} else {
				log_prefix = (yyvsp[0].strval);
			}
			}
#line 3354 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 903 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3360 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 904 "cfg.y" /* yacc.c:1646  */
    { IFOR(); enable_asserts=(yyvsp[0].intval); }
#line 3366 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 905 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3372 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 906 "cfg.y" /* yacc.c:1646  */
    { IFOR(); abort_on_assert=(yyvsp[0].intval); }
#line 3378 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 907 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3384 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 908 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			debug_mode=(yyvsp[0].intval);
			if (debug_mode) {
				*log_level = L_DBG;
				stderr_enabled=1;
				syslog_enabled=0;

				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, 0);
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, 1);
			}
			}
#line 3404 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 924 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected for debug_mode"); }
#line 3410 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 927 "cfg.y" /* yacc.c:1646  */
    { IFOR(); log_stdout=(yyvsp[0].intval); }
#line 3416 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 928 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3422 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 929 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			warn("'log_stderror' is deprecated, use 'stderror_enabled' and/or"
				"'syslog_enabled' instead");
			if (!config_check && !debug_mode) {
				if ((yyvsp[0].intval)) {
					stderr_enabled=1;
					syslog_enabled=0;
				} else {
					stderr_enabled=0;
					syslog_enabled=1;
				}

				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, (yyvsp[0].intval));
			}
			}
#line 3448 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 950 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3454 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 951 "cfg.y" /* yacc.c:1646  */
    {
			/* in config-check or debug mode we force logging
			 * to standard error */
			IFOR();
			if (!config_check && !debug_mode) {
				stderr_enabled=(yyvsp[0].intval);
				s_tmp.s=STDERR_CONSUMER_NAME;
				s_tmp.len=strlen(STDERR_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
			}
			}
#line 3470 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 962 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3476 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 963 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			/* in config-check or debug mode we force logging
			 * to standard error */
			if (!config_check && !debug_mode) {
				syslog_enabled=(yyvsp[0].intval);
				s_tmp.s=SYSLOG_CONSUMER_NAME;
				s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
				set_log_consumer_mute_state(&s_tmp, !(yyvsp[0].intval));
			}
			}
#line 3492 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 974 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3498 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 975 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			if ((yyvsp[0].intval)) {
				if (init_log_msg_buf(0) < 0) {
					yyerror("failed to allocate msg log buffer");
					YYABORT;
				}
			}
			log_event_enabled=(yyvsp[0].intval); }
#line 3512 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 984 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3518 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 985 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			s_tmp.s=STDERR_CONSUMER_NAME;
			s_tmp.len=strlen(STDERR_CONSUMER_NAME);
			set_log_consumer_level_filter(&s_tmp, (yyvsp[0].intval));
			}
#line 3529 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 991 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3535 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 992 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			s_tmp.s=SYSLOG_CONSUMER_NAME;
			s_tmp.len=strlen(SYSLOG_CONSUMER_NAME);
			set_log_consumer_level_filter(&s_tmp, (yyvsp[0].intval));
			}
#line 3546 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 998 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3552 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 999 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							log_event_level_filter = (yyvsp[0].intval); }
#line 3559 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1001 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3565 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1002 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			s_tmp.s = (yyvsp[0].strval);
			s_tmp.len = strlen((yyvsp[0].strval));
			if ((i_tmp = parse_log_format(&s_tmp)) < 0) {
				yyerror("unknown log format");
			} else {
				if (i_tmp != LOG_FORMAT_PLAIN) {
					if (init_log_json_buf(0) < 0) {
						yyerror("failed to allocate json log buffer");
						YYABORT;
					}
					if (init_log_msg_buf(0) < 0) {
						yyerror("failed to allocate msg log buffer");
						YYABORT;
					}

					if (i_tmp == LOG_FORMAT_JSON_CEE && init_log_cee_hostname() < 0) {
						yyerror("failed to allocate hostname buffer");
						YYABORT;
					}
				}

				stderr_log_format = i_tmp;
			}
			}
#line 3595 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1027 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			s_tmp.s = (yyvsp[0].strval);
			s_tmp.len = strlen((yyvsp[0].strval));
			if ((i_tmp = parse_log_format(&s_tmp)) < 0) {
				yyerror("unknown log format");
			} else {
				if (i_tmp != LOG_FORMAT_PLAIN) {
					if (init_log_json_buf(0) < 0) {
						yyerror("failed to allocate json log buffer");
						YYABORT;
					}
					if (init_log_msg_buf(0) < 0) {
						yyerror("failed to allocate msg log buffer");
						YYABORT;
					}

					if (i_tmp == LOG_FORMAT_JSON_CEE && init_log_cee_hostname() < 0) {
						yyerror("failed to allocate hostname buffer");
						YYABORT;
					}
				}

				syslog_log_format = i_tmp;
			}
			}
#line 3625 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1052 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			log_json_buf_size = (yyvsp[0].intval);
			if (init_log_json_buf(1) < 0) {
				yyerror("failed to realloc json log buffer");
				YYABORT;
			}
			}
#line 3638 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1060 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3644 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1061 "cfg.y" /* yacc.c:1646  */
    {
			IFOR();
			log_msg_buf_size = (yyvsp[0].intval);
			if (init_log_msg_buf(1) < 0) {
				yyerror("failed to realloc msg log buffer");
				YYABORT;
			}
			}
#line 3657 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1069 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3663 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1070 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			warn("'log_facility' is deprecated, use 'syslog_facility' instead");
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3675 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1077 "cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 3681 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1078 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
				yyerror("bad facility (see syslog(3) man page)");
			if (!config_check)
				log_facility=i_tmp;
			}
#line 3692 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1084 "cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 3698 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1085 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			warn("'log_name' is deprecated, use 'syslog_name' instead");
			log_name=(yyvsp[0].strval); }
#line 3706 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1088 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3712 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1089 "cfg.y" /* yacc.c:1646  */
    { IFOR(); log_name=(yyvsp[0].strval); }
#line 3718 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1090 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 3724 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1091 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 3730 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1092 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3736 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1093 "cfg.y" /* yacc.c:1646  */
    { IFOR(); received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 3742 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1094 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3748 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1095 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_ipv6=(yyvsp[0].intval); }
#line 3754 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1096 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3760 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1097 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_try_naptr=(yyvsp[0].intval); }
#line 3766 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1098 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3772 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1099 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_time=(yyvsp[0].intval); }
#line 3778 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1100 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3784 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1101 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_retr_no=(yyvsp[0].intval); }
#line 3790 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1102 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3796 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1103 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_servers_no=(yyvsp[0].intval); }
#line 3802 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1104 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3808 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1105 "cfg.y" /* yacc.c:1646  */
    { IFOR(); dns_search_list=(yyvsp[0].intval); }
#line 3814 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1106 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3820 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1107 "cfg.y" /* yacc.c:1646  */
    { IFOR(); max_while_loops=(yyvsp[0].intval); }
#line 3826 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1108 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3832 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1109 "cfg.y" /* yacc.c:1646  */
    { IFOR(); maxbuffer=(yyvsp[0].intval); }
#line 3838 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1110 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3844 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1111 "cfg.y" /* yacc.c:1646  */
    { IFOR(); udp_workers_no=(yyvsp[0].intval); }
#line 3850 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1112 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				udp_workers_no=(yyvsp[-2].intval);
				udp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3859 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1116 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 3865 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1117 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[0].intval);
		}
#line 3873 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1120 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				timer_workers_no=(yyvsp[-2].intval);
				timer_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 3882 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1124 "cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 3888 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1125 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 3894 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1126 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_hash_split_percentage=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3907 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1134 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
				}
#line 3920 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1142 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			shm_secondary_hash_size=(yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3933 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1150 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3946 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1158 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_enabled = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with support"
				" for HP_MALLOC\n");
			#endif
			}
#line 3959 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1166 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3972 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1174 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_pattern_file = (yyvsp[0].strval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 3985 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1182 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("string expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 3998 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1190 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef HP_MALLOC
			mem_warming_percentage = (yyvsp[0].intval);
			#else
			LM_ERR("Cannot set parameter; Please recompile with "
				"support for HP_MALLOC\n");
			#endif
			}
#line 4011 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1198 "cfg.y" /* yacc.c:1646  */
    {
			#ifdef HP_MALLOC
			yyerror("number expected");
			#else
			LM_ERR("Cannot set parameter; Please recompile with support "
				"for HP_MALLOC\n");
			#endif
			}
#line 4024 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1206 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_file = (yyvsp[0].strval);
			}
#line 4032 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1209 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4038 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1210 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			rpm_mem_size = (yyvsp[0].intval) * 1024 * 1024;
			}
#line 4046 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1213 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4052 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1214 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memlog=(yyvsp[0].intval); memdump=(yyvsp[0].intval); }
#line 4058 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1215 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4064 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1216 "cfg.y" /* yacc.c:1646  */
    { IFOR(); shm_memlog_size=(yyvsp[0].intval);}
#line 4070 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1217 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4076 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1218 "cfg.y" /* yacc.c:1646  */
    { IFOR(); memdump=(yyvsp[0].intval); }
#line 4082 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1219 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4088 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1220 "cfg.y" /* yacc.c:1646  */
    {  IFOR();execmsgthreshold=(yyvsp[0].intval); }
#line 4094 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1221 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4100 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1222 "cfg.y" /* yacc.c:1646  */
    { IFOR(); execdnsthreshold=(yyvsp[0].intval); }
#line 4106 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1223 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4112 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1224 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tcpthreshold=(yyvsp[0].intval); }
#line 4118 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1225 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4124 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1226 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("SHM threshold has to be a percentage between"
					" 0 and 100");
			event_shm_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif /* STATISTICS */
			}
#line 4139 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1236 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4145 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1237 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifdef PKG_MALLOC
			#ifdef STATISTICS
			if ((yyvsp[0].intval) < 0 || (yyvsp[0].intval) > 100)
				yyerror("PKG threshold has to be a percentage between "
					"0 and 100");
			event_pkg_threshold=(yyvsp[0].intval);
			#else
			yyerror("statistics support not compiled in");
			#endif
			#else
			yyerror("pkg_malloc support not compiled in");
			#endif
			}
#line 4164 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1251 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4170 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1252 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_buffer_size=(yyvsp[0].intval); }
#line 4176 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1253 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4182 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1254 "cfg.y" /* yacc.c:1646  */
    { IFOR(); query_flush_time=(yyvsp[0].intval); }
#line 4188 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1255 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4194 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1256 "cfg.y" /* yacc.c:1646  */
    { IFOR(); sip_warning=(yyvsp[0].intval); }
#line 4200 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1257 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4206 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1258 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4212 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1259 "cfg.y" /* yacc.c:1646  */
    { IFOR(); chroot_dir=(yyvsp[0].strval); }
#line 4218 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1260 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4224 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1261 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4230 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1262 "cfg.y" /* yacc.c:1646  */
    { IFOR(); working_dir=(yyvsp[0].strval); }
#line 4236 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1263 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4242 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1264 "cfg.y" /* yacc.c:1646  */
    { IFOR(); mhomed=(yyvsp[0].intval); }
#line 4248 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1265 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4254 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1266 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
								}
#line 4269 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1276 "cfg.y" /* yacc.c:1646  */
    { IFOR();
									io_poll_method=get_poll_type((yyvsp[0].strval));
									if (io_poll_method==POLL_NONE){
										LM_CRIT("bad poll method name:"
											" %s\n, try one of %s.\n",
											(yyvsp[0].strval), poll_support);
										yyerror("bad poll_method "
											"value");
									}
									}
#line 4284 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1286 "cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 4290 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1287 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if ((yyvsp[0].intval) < TCP_ALIAS_NEVER || (yyvsp[0].intval) > TCP_ALIAS_ALWAYS)
					yyerror("invalid 'tcp_accept_aliases' value");
				tcp_accept_aliases=(yyvsp[0].intval);
		}
#line 4300 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1292 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4306 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1293 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[0].intval);
		}
#line 4314 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1296 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_workers_no=(yyvsp[-2].intval);
				tcp_auto_scaling_profile=(yyvsp[0].strval);
		}
#line 4323 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1300 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4329 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1301 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if ((yyvsp[0].intval) <= 0)
					yyerror("invalid 'tcp_connect_timeout' (value too low!)");
				tcp_connect_timeout=(yyvsp[0].intval);
		}
#line 4339 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1306 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4345 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1307 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_con_lifetime=(yyvsp[0].intval);
		}
#line 4353 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1310 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4359 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1311 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_socket_backlog=(yyvsp[0].intval);
		}
#line 4367 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1314 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4373 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1315 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_connections=(yyvsp[0].intval);
		}
#line 4381 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1318 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4387 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1319 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_bflag =
					get_flag_id_by_name(FLAG_TYPE_BRANCH, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_bflag ) )
					yyerror("invalid TCP no_new_conn Branch Flag");
				flag_idx2mask( &tcp_no_new_conn_bflag );
		}
#line 4399 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1326 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 4405 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1327 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_no_new_conn_rplflag =
					get_flag_id_by_name(FLAG_TYPE_MSG, (yyvsp[0].strval), 0);
				if (!flag_in_range( (flag_t)tcp_no_new_conn_rplflag ) )
					yyerror("invalid TCP no_new_conn RePLy Flag");
				flag_idx2mask( &tcp_no_new_conn_rplflag );
		}
#line 4417 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1334 "cfg.y" /* yacc.c:1646  */
    { yyerror("number value expected"); }
#line 4423 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1336 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_keepalive=!!(yyvsp[0].intval);
		}
#line 4431 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1339 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4437 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1340 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_max_msg_time=(yyvsp[0].intval);
		}
#line 4445 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1343 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4451 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1344 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				tcp_parallel_read_on_workers=!!(yyvsp[0].intval);
		}
#line 4459 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1347 "cfg.y" /* yacc.c:1646  */
    {
			yyerror("boolean value expected");
		}
#line 4467 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1350 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPCNT
				warn("cannot be enabled TCP_KEEPCOUNT (no OS support)");
			#else
				tcp_keepcount=(yyvsp[0].intval);
			#endif
		}
#line 4479 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1357 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4485 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1358 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPIDLE
				warn("cannot be enabled TCP_KEEPIDLE (no OS support)");
			#else
				tcp_keepidle=(yyvsp[0].intval);
			#endif
		}
#line 4497 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1365 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4503 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1366 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			#ifndef HAVE_TCP_KEEPINTVL
				warn("cannot be enabled TCP_KEEPINTERVAL (no OS support)");
			#else
				tcp_keepinterval=(yyvsp[0].intval);
			 #endif
		}
#line 4515 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1373 "cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 4521 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1374 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_signature=(yyvsp[0].intval); }
#line 4528 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1376 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4534 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1377 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							server_header->s=(yyvsp[0].strval);
							server_header->len=strlen((yyvsp[0].strval));
							}
#line 4543 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1381 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4549 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1382 "cfg.y" /* yacc.c:1646  */
    { user_agent_header->s=(yyvsp[0].strval);
			user_agent_header->len=strlen((yyvsp[0].strval));
									}
#line 4557 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1385 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4563 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1386 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							pv_print_buf_size = (yyvsp[0].intval); }
#line 4570 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1388 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4576 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1389 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_buf_size = (yyvsp[0].intval); }
#line 4583 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1391 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_force_color = (yyvsp[0].intval); }
#line 4590 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1393 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							xlog_print_level = (yyvsp[0].intval); }
#line 4597 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1395 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4603 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1396 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4609 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1397 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4615 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1398 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							*xlog_level = (yyvsp[0].intval); }
#line 4622 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1400 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4628 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1401 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							for (lst_tmp = (yyvsp[0].sockid); lst_tmp; lst_tmp = lst_tmp->next) {
								if (add_listening_socket(lst_tmp)!=0){
									LM_CRIT("cfg. parser: failed"
											" to add listening socket\n");
									break;
								}
							}
						}
#line 4642 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1410 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4650 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1413 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							warn("'listen' is deprecated, use 'socket' instead");
							for (lst_tmp = (yyvsp[0].sockid); lst_tmp; lst_tmp = lst_tmp->next) {
								if (add_listening_socket(lst_tmp)!=0){
									LM_CRIT("cfg. parser: failed"
											" to add listen address\n");
									break;
								}
							}
						}
#line 4665 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1423 "cfg.y" /* yacc.c:1646  */
    { yyerror("ip address or hostname "
						"expected (use quotes if the hostname includes"
						" config keywords)"); }
#line 4673 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1426 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							/* convert STIRNG ($3) to an ID */
							/* update the memstats type for each module */
							#ifndef SHM_EXTRA_STATS
								LM_CRIT("SHM_EXTRA_STATS not defined");
								YYABORT;
							#else

							#ifdef SHM_SHOW_DEFAULT_GROUP
							if(strcmp((yyvsp[-2].strval), "default") == 0){
								LM_CRIT("default group  name is not allowed");
								YYABORT;
							}
							#endif

							for(tmp_mod = mod_names; tmp_mod; tmp_mod=tmp_mod->next){
								if(strcmp((yyvsp[-2].strval), tmp_mod->s) == 0){
									LM_CRIT("The same mem-group name is used twice: [%s] [%s]\n", (yyvsp[-2].strval), tmp_mod->s);
									YYABORT;
								}
							}

							tmp_mod = pkg_malloc(sizeof(struct multi_str));
							if(!tmp_mod){
								LM_CRIT("out of pkg memory");
								YYABORT;
							}

							tmp_mod->s = (yyvsp[-2].strval);
							tmp_mod->next = mod_names;
							mod_names = tmp_mod;
							for (tmp_mod = (yyvsp[0].multistr); tmp_mod; tmp_mod = tmp_mod->next){
								if(set_mem_idx(tmp_mod->s, mem_free_idx)){
									YYABORT;
								}
							}

							mem_free_idx++;

							if(alloc_group_stat()){
								YYABORT;
							}
							#endif
						}
#line 4722 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1470 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid or no module specified"); }
#line 4728 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1471 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next)
								add_alias(lst_tmp->name, strlen(lst_tmp->name),
											lst_tmp->port, lst_tmp->proto);
							  }
#line 4738 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1476 "cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected (use quotes"
							" if the hostname includes config keywords)"); }
#line 4745 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1478 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								auto_aliases=(yyvsp[0].intval); }
#line 4752 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1480 "cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 4758 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1481 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								if ((yyvsp[0].strval)) {
									default_global_address->s=(yyvsp[0].strval);
									default_global_address->len=strlen((yyvsp[0].strval));
								}
								}
#line 4769 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1487 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4776 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1489 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								tmp = int2str((yyvsp[0].intval), &i_tmp);
								if (i_tmp > default_global_port->len)
									default_global_port->s =
									pkg_realloc(default_global_port->s, i_tmp);
								if (!default_global_port->s) {
									LM_CRIT("cfg. parser: out of memory.\n");
									YYABORT;
								} else {
									default_global_port->len = i_tmp;
									memcpy(default_global_port->s, tmp,
											default_global_port->len);
								}
								}
#line 4795 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1503 "cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname "
												"expected"); }
#line 4802 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1505 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_core_dump=(yyvsp[0].intval);
									}
#line 4810 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1508 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4816 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1509 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										open_files_limit=(yyvsp[0].intval);
									}
#line 4824 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1512 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4830 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1513 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_loopback=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4842 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1520 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4848 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1521 "cfg.y" /* yacc.c:1646  */
    { IFOR();
								#ifdef USE_MCAST
										mcast_ttl=(yyvsp[0].intval);
								#else
									warn("no multicast support compiled in");
								#endif
		  }
#line 4860 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1528 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected as tos"); }
#line 4866 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1529 "cfg.y" /* yacc.c:1646  */
    { IFOR(); tos = (yyvsp[0].intval);
							if (tos<=0)
								yyerror("invalid tos value");
		 }
#line 4875 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1533 "cfg.y" /* yacc.c:1646  */
    { IFOR();
							if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
								tos=IPTOS_LOWDELAY;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
								tos=IPTOS_THROUGHPUT;
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
								tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
								tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
							} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
								tos=IPTOS_LOWCOST;
#endif
							} else {
								yyerror("invalid tos value - allowed: "
									"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
									"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
									",IPTOS_LOWCOST"
#endif
#if defined(IPTOS_MINCOST)
									",IPTOS_MINCOST"
#endif
									"\n");
							}
		 }
#line 4908 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1561 "cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 4914 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1562 "cfg.y" /* yacc.c:1646  */
    {IFOR();
				add_mpath((yyvsp[0].strval)); }
#line 4921 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1564 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 4927 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1565 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_failover=(yyvsp[0].intval);
									}
#line 4935 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1568 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4941 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1569 "cfg.y" /* yacc.c:1646  */
    { IFOR();
										disable_dns_blacklist=(yyvsp[0].intval);
									}
#line 4949 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1572 "cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 4955 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1573 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				s_tmp.s = (yyvsp[-3].strval);
				s_tmp.len = strlen((yyvsp[-3].strval));
				if (create_bl_head(_str("script"), (yyvsp[-1].intval),
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4970 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1583 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				s_tmp.s = (yyvsp[-1].strval);
				s_tmp.len = strlen((yyvsp[-1].strval));
				if (create_bl_head(_str("script"), BL_READONLY_LIST,
				    bl_head, bl_tail, &s_tmp)==0) {
					yyerror("failed to create blacklist\n");
					YYABORT;
				}
				bl_head = bl_tail = NULL;
				}
#line 4985 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1593 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				sl_fwd_disabled=(yyvsp[0].intval); }
#line 4992 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1595 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_version_table=(yyvsp[0].strval); }
#line 4999 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1597 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5005 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1598 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_default_url=(yyvsp[0].strval); }
#line 5012 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1600 "cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5018 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1601 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				db_max_async_connections=(yyvsp[0].intval); }
#line 5025 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1603 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 5033 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1606 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				disable_503_translation=(yyvsp[0].intval); }
#line 5040 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1608 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 5048 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1611 "cfg.y" /* yacc.c:1646  */
    {}
#line 5054 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1612 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("bad auto-scaling profile definition");
				}
#line 5062 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1615 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				auto_scaling_cycle=(yyvsp[0].intval); }
#line 5069 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1617 "cfg.y" /* yacc.c:1646  */
    {
				yyerror("integer value expected");
				}
#line 5077 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1620 "cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 5083 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1623 "cfg.y" /* yacc.c:1646  */
    { IFOR();
			if (load_module((yyvsp[0].strval)) < 0)
				yyerrorf("failed to load module %s\n", (yyvsp[0].strval));
		}
#line 5092 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1627 "cfg.y" /* yacc.c:1646  */
    { yyerror("string expected");  }
#line 5098 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1628 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5109 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1634 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), STR_PARAM, (yyvsp[-1].strval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5120 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1640 "cfg.y" /* yacc.c:1646  */
    { IFOR();
				if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), INT_PARAM, (void*)(yyvsp[-1].intval)) != 0) {
					yyerrorf("Parameter <%s> not found in module <%s> - "
						"can't set", (yyvsp[-3].strval), (yyvsp[-5].strval));
				}
			}
#line 5131 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1646 "cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 5137 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1650 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5143 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1651 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5149 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1654 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv4 address");
						}
					}
				}
#line 5168 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1670 "cfg.y" /* yacc.c:1646  */
    {
					(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
					if ((yyval.ipaddr)==0){
						LM_CRIT("ERROR: cfg. parser: out of memory.\n");
						YYABORT;
					}else{
						memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
						(yyval.ipaddr)->af=AF_INET6;
						(yyval.ipaddr)->len=16;
						if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0){
							yyerror("bad ipv6 address");
						}
					}
				}
#line 5187 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1686 "cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 5193 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1687 "cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 5199 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1690 "cfg.y" /* yacc.c:1646  */
    {
				if (parse_ipnet((yyvsp[0].strval), strlen((yyvsp[0].strval)), &net_tmp) < 0)
					yyerror("unable to parse ip and/or netmask\n");

				(yyval.ipnet) = net_tmp;
			}
#line 5210 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1696 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.ipnet)=mk_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8);
				pkg_free((yyvsp[0].ipaddr));
			}
#line 5219 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1706 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					yyerror("cfg. parser: out of memory");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5234 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1716 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = pkg_malloc( strlen((yyvsp[-1].strval)) + strlen((yyvsp[0].strval)) + 1);
				if ((yyval.strval)==0){
					LM_CRIT("ERROR: cfg. parser: out of memory.\n");
					YYABORT;
				} else {
					strcpy((yyval.strval),(yyvsp[-1].strval)); strcat((yyval.strval),(yyvsp[0].strval));
					pkg_free((yyvsp[-1].strval)); pkg_free((yyvsp[0].strval));
				}
			}
#line 5249 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1727 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
				}
#line 5257 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1730 "cfg.y" /* yacc.c:1646  */
    {
				tmp=int2str((yyvsp[0].intval), &i_tmp);
				if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
					yyerror("cfg. parser: out of memory.\n");
					YYABORT;
				}
				memcpy( (yyval.strval), tmp, i_tmp);
				(yyval.strval)[i_tmp] = 0;
				}
#line 5271 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1739 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.strval) = (yyvsp[0].strval);
		}
#line 5279 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1744 "cfg.y" /* yacc.c:1646  */
    {
				/* check to see if there are any "$" in the string name */
				tmp = strchr((yyvsp[0].strval), '$');
				if (!tmp) {
					/* route name is a cosntant string - search for the route */
					rn_tmp.data = 0;
					rn_tmp.iname = get_script_route_idx((yyvsp[0].strval), sroutes->request,
							RT_NO, 0);
					if (rn_tmp.iname==-1)
						yyerror("too many script routes");
					(yyval.intval) = NUMBER_ST;
				} else {
					tstr.s = (yyvsp[0].strval);
					tstr.len = strlen(tstr.s);
					if (pv_parse_format(&tstr, &elem) < 0) {
						yyerror("cannot parse format");
						YYABORT;
					}
					/* the route name is a format, so we can't evaluate it now */
					rn_tmp.ename = elem;
					(yyval.intval) = SCRIPTVAR_ELEM_ST;
				}
			}
#line 5307 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1767 "cfg.y" /* yacc.c:1646  */
    {
				rn_tmp.sname = (yyvsp[0].specval);
				(yyval.intval) = SCRIPTVAR_ST;
		}
#line 5316 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1772 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->request[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"request routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
					}
#line 5329 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1780 "cfg.y" /* yacc.c:1646  */
    {
						if ( strtol((yyvsp[-4].strval),&tmp,10)==0 && *tmp==0) {
							/* route[0] detected */
							if (sroutes->request[DEFAULT_RT].a!=0) {
								yyerror("overwriting(2) default "
									"request routing table");
								YYABORT;
							}
							push((yyvsp[-1].action), &sroutes->request[DEFAULT_RT].a);
						} else {
							i_tmp = get_script_route_idx( (yyvsp[-4].strval),
								sroutes->request, RT_NO,1);
							if (i_tmp==-1) YYABORT;
							push((yyvsp[-1].action), &sroutes->request[i_tmp].a);
						}
					}
#line 5350 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1796 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 5356 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1799 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->failure,
							FAILURE_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->failure[i_tmp].a);
					}
#line 5367 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1805 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 5373 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1808 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->onreply[DEFAULT_RT].a!=0) {
							yyerror("overwriting default "
								"onreply routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->onreply[DEFAULT_RT].a);
					}
#line 5386 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1816 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->onreply,
							ONREPLY_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->onreply[i_tmp].a);
					}
#line 5397 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1822 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 5403 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1825 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx( (yyvsp[-4].strval), sroutes->branch,
							BRANCH_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->branch[i_tmp].a);
					}
#line 5414 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1831 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 5420 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1834 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->error.a!=0) {
							yyerror("overwriting default "
								"error routing table");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->error.a);
					}
#line 5433 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1842 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid error_route statement"); }
#line 5439 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1845 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->local.a!=0) {
							yyerror("re-definition of local "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->local.a);
					}
#line 5452 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1853 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid local_route statement"); }
#line 5458 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1856 "cfg.y" /* yacc.c:1646  */
    {
						if (sroutes->startup.a!=0) {
							yyerror("re-definition of startup "
								"route detected");
							YYABORT;
						}
						push((yyvsp[-1].action), &sroutes->startup.a);
					}
#line 5471 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1864 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid startup_route statement"); }
#line 5477 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1867 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = 0;
						while(i_tmp<TIMER_RT_NO && sroutes->timer[i_tmp].a!=0){
							i_tmp++;
						}
						if(i_tmp == TIMER_RT_NO) {
							yyerror("Too many timer routes defined\n");
							YYABORT;
						}
						sroutes->timer[i_tmp].name = (yyvsp[-6].strval);
						sroutes->timer[i_tmp].interval = (yyvsp[-4].intval);
						push((yyvsp[-1].action), &sroutes->timer[i_tmp].a);
					}
#line 5495 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1880 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid timer_route statement"); }
#line 5501 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1883 "cfg.y" /* yacc.c:1646  */
    {
						i_tmp = get_script_route_idx((yyvsp[-4].strval), sroutes->event,
								EVENT_RT_NO,1);
						if (i_tmp==-1) YYABORT;
						push((yyvsp[-1].action), &sroutes->event[i_tmp].a);
					}
#line 5512 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1889 "cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 5518 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1894 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(AND_OP, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5524 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1895 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(OR_OP, (yyvsp[-2].expr), (yyvsp[0].expr));  }
#line 5530 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1896 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(NOT_OP, (yyvsp[0].expr), 0);  }
#line 5536 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1897 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_exp(EVAL_OP, (yyvsp[-1].expr), 0); }
#line 5542 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1898 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[-1].expr); }
#line 5548 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1899 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=(yyvsp[0].expr); }
#line 5554 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1902 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 5560 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1903 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 5566 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1906 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 5572 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1907 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 5578 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1908 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 5584 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1909 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 5590 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1911 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 5596 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1912 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=NOTMATCH_OP; }
#line 5602 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1915 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5608 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1916 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5614 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1919 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5620 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1920 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5626 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1921 "cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 5632 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1924 "cfg.y" /* yacc.c:1646  */
    {
				spec = (pv_spec_t*)pkg_malloc(sizeof(pv_spec_t));
				if (spec==NULL){
					yyerror("no more pkg memory\n");
					YYABORT;
				}
				memset(spec, 0, sizeof(pv_spec_t));
				tstr.s = (yyvsp[0].strval);
				tstr.len = strlen(tstr.s);
				if(pv_parse_spec(&tstr, spec)==NULL)
				{
					yyerror("unknown script variable");
				}

				(yyval.specval) = spec;
			}
#line 5653 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1940 "cfg.y" /* yacc.c:1646  */
    {
			(yyval.specval)=0; yyerror("invalid script variable name");
		}
#line 5661 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1945 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=(yyvsp[0].expr); }
#line 5667 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1946 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5673 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1947 "cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem( NO_OP, NUMBER_O, 0, NUMBER_ST,
											(void*)(yyvsp[0].intval) ); }
#line 5680 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1949 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem(NO_OP, SCRIPTVAR_O,0,SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5688 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1954 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),SCRIPTVAR_ST,(void*)(yyvsp[0].specval));
			}
#line 5696 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1957 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),STR_ST,(yyvsp[0].strval));
			}
#line 5704 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1960 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval),NUMBER_ST,(void *)(yyvsp[0].intval));
			}
#line 5712 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1963 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem( (yyvsp[-1].intval), SCRIPTVAR_O,(void*)(yyvsp[-2].specval), NULLV_ST, 0);
			}
#line 5720 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1966 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr)=mk_elem((yyvsp[-1].intval), SCRIPTVAR_O, (void*)(yyvsp[-2].specval), NET_ST, (yyvsp[0].ipnet));
			}
#line 5728 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1972 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = EQ_T; }
#line 5734 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1973 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = COLONEQ_T; }
#line 5740 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1974 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = PLUSEQ_T; }
#line 5746 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1975 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MINUSEQ_T;}
#line 5752 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1976 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = DIVEQ_T; }
#line 5758 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1977 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MULTEQ_T; }
#line 5764 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1978 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = MODULOEQ_T; }
#line 5770 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1979 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BANDEQ_T; }
#line 5776 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1980 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BOREQ_T; }
#line 5782 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1981 "cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = BXOREQ_T; }
#line 5788 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1985 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, NUMBERV_O, (void*)(yyvsp[0].intval), 0, 0); }
#line 5794 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1986 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, STRINGV_O, (yyvsp[0].strval), 0, 0); }
#line 5800 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1987 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = mk_elem(VALUE_OP, SCRIPTVAR_O, (yyvsp[0].specval), 0, 0); }
#line 5806 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1988 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)= (yyvsp[0].expr); }
#line 5812 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1989 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem( NO_OP, ACTION_O, 0, ACTIONS_ST, (yyvsp[0].action) ); }
#line 5818 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1990 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(PLUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5826 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1993 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MINUS_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5834 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1996 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MULT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5842 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1999 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(DIV_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5850 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2002 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(MODULO_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5858 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2005 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BAND_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5866 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2008 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5874 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2011 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BXOR_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5882 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2014 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BLSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5890 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2017 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BRSHIFT_OP, EXPR_O, (yyvsp[-2].expr), EXPR_ST, (yyvsp[0].expr));
			}
#line 5898 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2020 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.expr) = mk_elem(BNOT_OP, EXPR_O, (yyvsp[0].expr), 0, 0);
			}
#line 5906 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2023 "cfg.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 5912 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2026 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), (yyvsp[-1].intval),
					SCRIPTVAR_ST,
					EXPR_ST,
					(yyvsp[-2].specval),
					(yyvsp[0].expr));
		}
#line 5930 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2039 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), EQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5948 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2052 "cfg.y" /* yacc.c:1646  */
    {
			if(!pv_is_w((yyvsp[-2].specval)))
				yyerror("invalid left operand in assignment");
			if((yyvsp[-2].specval)->trans!=0)
				yyerror("transformations not accepted in left side "
					"of assignment");

			mk_action2( (yyval.action), COLONEQ_T,
					SCRIPTVAR_ST,
					NULLV_ST,
					(yyvsp[-2].specval),
					0);
		}
#line 5966 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2067 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5972 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2068 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5978 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2069 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 5984 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2070 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 5990 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2071 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 5996 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2074 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 6002 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2075 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 6008 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2076 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 6014 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2079 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 6020 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2080 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 6026 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2081 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; }
#line 6032 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2084 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6038 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2085 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6044 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2086 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 6050 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2090 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6056 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2091 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6062 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2092 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command!)"); }
#line 6068 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2095 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6074 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2096 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6080 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2097 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6086 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2098 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6092 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2099 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6098 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2100 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6104 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2101 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 6110 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2102 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 6116 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2105 "cfg.y" /* yacc.c:1646  */
    { mk_action0((yyval.action), BREAK_T);}
#line 6122 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2106 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6128 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2107 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6134 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2108 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6140 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2109 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6146 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2110 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6152 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2111 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 6158 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2112 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 6164 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2113 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 6170 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2116 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 6183 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2124 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 6196 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2134 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 NOSUBTYPE,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action),
													 0);
									}
#line 6209 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2142 "cfg.y" /* yacc.c:1646  */
    { mk_action3( (yyval.action), IF_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 ACTIONS_ST,
													 (yyvsp[-4].expr),
													 (yyvsp[-2].action),
													 (yyvsp[0].action));
									}
#line 6222 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2152 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), WHILE_T,
													 EXPR_ST,
													 ACTIONS_ST,
													 (yyvsp[-2].expr),
													 (yyvsp[0].action));
									}
#line 6233 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2160 "cfg.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-4].specval)->type != PVT_SCRIPTVAR &&
					    (yyvsp[-4].specval)->type != PVT_AVP &&
						pv_type((yyvsp[-4].specval)->type) != PVT_JSON) {
						yyerror("\nfor-each statement: only \"var\", \"avp\" "
					            "and \"json\" iterators are supported!");
					}

					mk_action3( (yyval.action), FOR_EACH_T,
					            SCRIPTVAR_ST,
					            SCRIPTVAR_ST,
					            ACTIONS_ST,
					            (yyvsp[-4].specval),
					            (yyvsp[-2].specval),
					            (yyvsp[0].action));
					}
#line 6254 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2178 "cfg.y" /* yacc.c:1646  */
    {
											mk_action2( (yyval.action), SWITCH_T,
														SCRIPTVAR_ST,
														ACTIONS_ST,
														(yyvsp[-4].specval),
														(yyvsp[-1].action));
									}
#line 6266 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2187 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6272 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2188 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 6278 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2190 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 6284 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2191 "cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 6290 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2194 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].intval),
													(yyvsp[0].action));
											}
#line 6301 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2200 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													NUMBER_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].intval),
													NULL);
							}
#line 6312 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2206 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-2].strval),
													(yyvsp[0].action));
											}
#line 6323 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2212 "cfg.y" /* yacc.c:1646  */
    { mk_action2( (yyval.action), CASE_T,
													STR_ST,
													ACTIONS_ST,
													(void*)(yyvsp[-1].strval),
													NULL);
							}
#line 6334 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2220 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T,
													ACTIONS_ST, (yyvsp[0].action));
									}
#line 6342 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2223 "cfg.y" /* yacc.c:1646  */
    { mk_action1( (yyval.action), DEFAULT_T, ACTIONS_ST, NULL); }
#line 6348 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2226 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = STR_ST;
										elems[1].u.data = (yyvsp[0].strval);
										(yyval.intval)=1;
										}
#line 6358 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2231 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = STR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].strval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6373 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2241 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NULLV_ST;
										elems[2].u.data = NULL;
										(yyval.intval)=2;
										}
#line 6385 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2248 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = STR_ST;
										elems[2].u.data = (yyvsp[0].strval);
										(yyval.intval)=2;
										}
#line 6397 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2255 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-1].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-1].intval)+1].type = NULLV_ST;
										elems[(yyvsp[-1].intval)+1].u.data = NULL;
										(yyval.intval)=(yyvsp[-1].intval)+1;
										}
#line 6412 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2265 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NUMBER_ST;
										elems[1].u.number = (yyvsp[0].intval);
										(yyval.intval)=1;
										}
#line 6422 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2270 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = NUMBER_ST;
										elems[2].u.number = (yyvsp[0].intval);
										(yyval.intval)=2;
										}
#line 6434 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2277 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = NUMBER_ST;
										elems[(yyvsp[-2].intval)+1].u.number = (yyvsp[0].intval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6449 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2287 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = SCRIPTVAR_ST;
										elems[1].u.data = (yyvsp[0].specval);
										(yyval.intval)=1;
										}
#line 6459 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2292 "cfg.y" /* yacc.c:1646  */
    {
										elems[1].type = NULLV_ST;
										elems[1].u.data = NULL;
										elems[2].type = SCRIPTVAR_ST;
										elems[2].u.data = (yyvsp[0].specval);
										(yyval.intval)=2;
										}
#line 6471 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2299 "cfg.y" /* yacc.c:1646  */
    {
										if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
											yyerror("too many arguments "
												"in function\n");
											(yyval.intval)=0;
										}
										elems[(yyvsp[-2].intval)+1].type = SCRIPTVAR_ST;
										elems[(yyvsp[-2].intval)+1].u.data = (yyvsp[0].specval);
										(yyval.intval)=(yyvsp[-2].intval)+1;
										}
#line 6486 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2311 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = STRING_ST;
						route_elems[0].u.string = (yyvsp[0].strval);
						(yyval.intval)=1;
			}
#line 6496 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2316 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NUMBER_ST;
						route_elems[0].u.number = (long)(yyvsp[0].intval);
						(yyval.intval)=1;
			}
#line 6506 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2321 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = NULLV_ST;
						route_elems[0].u.data = 0;
						(yyval.intval)=1;
			}
#line 6516 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2326 "cfg.y" /* yacc.c:1646  */
    {
						route_elems[0].type = SCRIPTVAR_ST;
						route_elems[0].u.data = (yyvsp[0].specval);
						(yyval.intval)=1;
			}
#line 6526 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2331 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = STRING_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].strval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6541 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2341 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NUMBER_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (void*)(long)(yyvsp[0].intval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6556 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2351 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = SCRIPTVAR_ST;
							route_elems[(yyvsp[-2].intval)].u.data = (yyvsp[0].specval);
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6571 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2361 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-2].intval)+1>=MAX_ACTION_ELEMS) {
							yyerror("too many arguments in function\n");
							(yyval.intval)=-1;
						} else {
							route_elems[(yyvsp[-2].intval)].type = NULLV_ST;
							route_elems[(yyvsp[-2].intval)].u.data = 0;
							(yyval.intval)=(yyvsp[-2].intval)+1;
						}
			}
#line 6586 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2373 "cfg.y" /* yacc.c:1646  */
    {
				const acmd_export_t* acmd_tmp=find_mod_acmd_export_t((yyvsp[-2].strval));
				if (acmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-2].strval));
					(yyval.action)=0;
				}else{
					if (check_acmd_call_params(acmd_tmp,elems,0)<0) {
						yyerrorf("too few parameters "
							"for command <%s>\n", (yyvsp[-2].strval));
						(yyval.action)=0;
					} else {
						elems[0].type = ACMD_ST;
						elems[0].u.data_const = acmd_tmp;
						mk_action_((yyval.action), AMODULE_T, 1, elems);
					}
				}
			}
#line 6609 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2391 "cfg.y" /* yacc.c:1646  */
    {
				const acmd_export_t* acmd_tmp=find_mod_acmd_export_t((yyvsp[-3].strval));
				if (acmd_tmp==0){
					yyerrorf("unknown async command <%s>, "
						"missing loadmodule?", (yyvsp[-3].strval));
					(yyval.action)=0;
				}else{
					rc = check_acmd_call_params(acmd_tmp,elems,(yyvsp[-1].intval));
					switch (rc) {
					case -1:
						yyerrorf("too few parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -2:
						yyerrorf("too many parameters "
							"for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					case -3:
						yyerrorf("mandatory parameter "
							" omitted for async command <%s>\n", (yyvsp[-3].strval));
						(yyval.action)=0;
						break;
					default:
						elems[0].type = ACMD_ST;
						elems[0].u.data_const = acmd_tmp;
						mk_action_((yyval.action), AMODULE_T, (yyvsp[-1].intval)+1, elems);
					}
				}
			}
#line 6645 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2422 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bad arguments for command <%s>", (yyvsp[-3].strval));
			}
#line 6654 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2426 "cfg.y" /* yacc.c:1646  */
    {
				(yyval.action)=0;
				yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6663 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2432 "cfg.y" /* yacc.c:1646  */
    {
			mk_action2( (yyval.action), ASSERT_T, EXPR_ST, STRING_ST, (yyvsp[-3].expr), (yyvsp[-1].strval));
			}
#line 6671 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2435 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6677 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2436 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), DROP_T); }
#line 6683 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2437 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6689 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2438 "cfg.y" /* yacc.c:1646  */
    {mk_action0( (yyval.action), EXIT_T); }
#line 6695 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2440 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[0].specval)); }
#line 6701 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2442 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, SCRIPTVAR_ST, (void*)(yyvsp[-1].specval)); }
#line 6707 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2444 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[0].intval)); }
#line 6713 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2446 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)(yyvsp[-1].intval)); }
#line 6719 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2448 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6725 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2449 "cfg.y" /* yacc.c:1646  */
    {mk_action1( (yyval.action), RETURN_T, NUMBER_ST, (void*)1); }
#line 6731 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2450 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T, NUMBER_ST,
													STRING_ST,(void*)4,(yyvsp[-1].strval));
									}
#line 6739 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2453 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), LOG_T,
																NUMBER_ST,
																STRING_ST,
																(void*)(yyvsp[-3].intval),
																(yyvsp[-1].strval));
												}
#line 6750 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2459 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6756 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2460 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log"
									"argument"); }
#line 6763 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2462 "cfg.y" /* yacc.c:1646  */
    {mk_action2( (yyval.action), ERROR_T,
																STRING_ST,
																STRING_ST,
																(yyvsp[-3].strval),
																(yyvsp[-1].strval));
												  }
#line 6774 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2468 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6780 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2469 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error"
														"argument"); }
#line 6787 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2471 "cfg.y" /* yacc.c:1646  */
    {
						mk_action2( (yyval.action), ROUTE_T, (yyvsp[-1].intval), 0, rn_tmp.data, 0);
					}
#line 6795 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2475 "cfg.y" /* yacc.c:1646  */
    {
						if ((yyvsp[-1].intval) <= 0) yyerror("too many route parameters");

						/* duplicate the list */
						a_tmp = pkg_malloc((yyvsp[-1].intval) * sizeof(action_elem_t));
						if (!a_tmp) {
							yyerror("no more pkg memory");
							YYABORT;
						}
						memcpy(a_tmp, route_elems, (yyvsp[-1].intval)*sizeof(action_elem_t));

						mk_action3( (yyval.action), ROUTE_T, (yyvsp[-3].intval),	/* route idx */
							NUMBER_ST,					/* number of params */
							SCRIPTVAR_ST,				/* parameters */
							rn_tmp.data,
							(void*)(long)(yyvsp[-1].intval),
							(void*)a_tmp);
					}
#line 6818 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2494 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 6824 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2495 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route"
						"argument"); }
#line 6831 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2497 "cfg.y" /* yacc.c:1646  */
    {
								const cmd_export_t* cmd_tmp=find_cmd_export_t((yyvsp[-2].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-2].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-2].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-2].strval));
									}
									(yyval.action)=0;
								}else{
									if (check_cmd_call_params(cmd_tmp,elems,0)<0) {
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-2].strval));
										(yyval.action)=0;
									} else {
										elems[0].type = CMD_ST;
										elems[0].u.data_const = cmd_tmp;
										mk_action_((yyval.action), CMD_T, 1, elems);
									}
								}
							}
#line 6859 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2520 "cfg.y" /* yacc.c:1646  */
    {
								const cmd_export_t* cmd_tmp=find_cmd_export_t((yyvsp[-3].strval), rt);
								if (cmd_tmp==0){
									if (find_cmd_export_t((yyvsp[-3].strval), 0)) {
										yyerrorf("Command <%s> cannot be "
											"used in the block\n", (yyvsp[-3].strval));
									} else {
										yyerrorf("unknown command <%s>, "
											"missing loadmodule?", (yyvsp[-3].strval));
									}
									(yyval.action)=0;
								}else{
									rc = check_cmd_call_params(cmd_tmp,elems,(yyvsp[-1].intval));
									switch (rc) {
									case -1:
										yyerrorf("too few parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -2:
										yyerrorf("too many parameters "
											"for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									case -3:
										yyerrorf("mandatory parameter "
											"omitted for command <%s>\n", (yyvsp[-3].strval));
										(yyval.action)=0;
										break;
									default:
										elems[0].type = CMD_ST;
										elems[0].u.data_const = cmd_tmp;
										mk_action_((yyval.action), CMD_T, (yyvsp[-1].intval)+1, elems);
									}
								}
							}
#line 6900 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2556 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerrorf("bad arguments for "
												"command <%s>", (yyvsp[-3].strval)); }
#line 6907 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2558 "cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
			yyerrorf("bare word <%s> found, command calls need '()'", (yyvsp[-1].strval));
			}
#line 6915 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2561 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6922 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2563 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XDBG_T, STR_ST, (yyvsp[-1].strval));	}
#line 6929 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2565 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6936 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2567 "cfg.y" /* yacc.c:1646  */
    {
				mk_action1((yyval.action), XLOG_T, STR_ST, (yyvsp[-1].strval)); }
#line 6943 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2569 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6950 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2571 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), XLOG_T, STR_ST, STR_ST, (yyvsp[-3].strval), (yyvsp[-1].strval)); }
#line 6957 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2573 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-1].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action2((yyval.action), ASYNC_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-3].action), (void*)rt_ref);
				}
#line 6969 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2580 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-3].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action3((yyval.action), ASYNC_T, ACTIONS_ST, ROUTE_REF_ST, NUMBER_ST,
						(yyvsp[-5].action), (void*)rt_ref, (void*)(long)(yyvsp[-1].intval));
				}
#line 6981 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2587 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-3].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action3((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST, STRING_ST,
						(yyvsp[-5].action), (void*)rt_ref, (yyvsp[-1].strval));
				}
#line 6993 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2594 "cfg.y" /* yacc.c:1646  */
    {
				rt_ref = ref_script_route_by_name( (yyvsp[-1].strval), sroutes->request,
					RT_NO, REQUEST_ROUTE, 0);
				if (rt_ref==NULL) yyerror("fail to create route reference");
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-3].action), (void*)rt_ref);
				}
#line 7005 "cfg.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2601 "cfg.y" /* yacc.c:1646  */
    {
				mk_action2((yyval.action), LAUNCH_T, ACTIONS_ST, ROUTE_REF_ST,
						(yyvsp[-1].action), (void*)NULL);
				}
#line 7014 "cfg.tab.c" /* yacc.c:1646  */
    break;


#line 7018 "cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2608 "cfg.y" /* yacc.c:1906  */


static inline void ALLOW_UNUSED warn(char* s)
{
	LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
}

static void yyerror(char* s)
{
	cfg_dump_backtrace();
	LM_CRIT("parse error in %s:%d:%d-%d: %s\n",
			get_cfg_file_name, line, startcolumn, column, s);
	_cfg_dump_context(get_cfg_file_name, line, startcolumn, column, 1);
	cfg_errors++;
}

#define ERROR_MAXLEN 1024
static void yyerrorf(char *fmt, ...)
{
	char *tmp = pkg_malloc(ERROR_MAXLEN);
	va_list ap;
	va_start(ap, fmt);

	vsnprintf(tmp, ERROR_MAXLEN, fmt, ap);
	yyerror(tmp);

	pkg_free(tmp);
	va_end(ap);
}


static struct socket_id* mk_listen_id(char* host, enum sip_protos proto,
																	int port)
{
	struct socket_id* l;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0){
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		memset(l, 0, sizeof(*l));
		l->name     = host;
		l->proto    = proto;
		l->port     = port;
	}

	return l;
}

static struct socket_id* mk_listen_id_range(char* host, enum sip_protos proto, struct port_range *pr)
{
	int port;
	struct socket_id *sid, *first_sid = NULL;
	if (!pr)
		return mk_listen_id(host, proto, 0);
	while (pr) {
		for (port = pr->max; port >= pr->min; port--) {
			sid = mk_listen_id(host, proto, port);
			if (!sid)
				return first_sid;
			sid->next = first_sid;
			first_sid = sid;
		}
		pr = pr->next;
	}
	return first_sid;
}

static void fill_socket_id(struct listen_param *param, struct socket_id *s)
{
	int warn;
	struct socket_id *socket;
	while (s) {
		s->flags |= param->flags;
		s->workers = param->workers;
		s->auto_scaling_profile = param->auto_scaling_profile;
		s->tag = param->tag;
		if (param->socket) {
			socket = param->socket;
			param->socket = param->socket->next;
			set_listen_id_adv(s, socket->name, socket->port);
			pkg_free(socket);
		} else if (!warn) {
			LM_WARN("inconsistent port range with advertised ports - skipping advertised\n");
			warn = 1;
		}
		s = s->next;
	}
	/* free remaining sockets, if any */
	while (param->socket) {
		if (!warn) {
			LM_WARN("inconsistent port range with advertised ports - too many adverised\n");
			warn = 1;
		}
		socket = param->socket->next;
		param->socket = param->socket->next;
		pkg_free(socket);
	}
}

static struct multi_str *new_string(char *s)
{
	struct multi_str *ms = pkg_malloc(sizeof(struct multi_str));
	if (!ms) {
		LM_CRIT("cfg. parser: out of memory.\n");
	}else{
		ms->s    = s;
		ms->next = NULL;
	}
	return ms;
}

static struct port_range* mk_port_range(int min, int max)
{
	struct port_range *pr = pkg_malloc(sizeof *pr);
	if (pr) {
		memset(pr, 0, sizeof *pr);
		pr->min = min;
		pr->max = max;
		pr->next = NULL;
	} else {
		LM_CRIT("cfg. parser: out of memory.\n");
	}
	return pr;
}

static struct socket_id* set_listen_id_adv(struct socket_id* sock,
											char *adv_name,
											int adv_port)
{
	sock->adv_name=adv_name;
	sock->adv_port=adv_port;
	return sock;
}

static int parse_ipnet(char *in, int len, struct net **ipnet)
{
	char *p = NULL;
	str ip_s, mask_s;
	struct ip_addr *ip = NULL, *mask = NULL, *ip_tmp;
	int af;
	unsigned int bitlen;

	p = q_memchr(in, '.', len);
	if (p)
		af = AF_INET;
	else if (q_memchr(in, ':', len)) {
		af = AF_INET6;
	} else {
		LM_ERR("Not an IP");
		return -1;
	}

	p = q_memchr(in, '/', len);
	if (!p) {
		LM_ERR("No netmask\n");
		return -1;
	}
	ip_s.s = in;
	ip_s.len = p - in;

	mask_s.s = p + 1;
	mask_s.len = len - ip_s.len - 1;
	if (!mask_s.s || mask_s.len == 0) {
		LM_ERR("Empty netmask\n");
		return -1;
	}

	ip_tmp = (af == AF_INET) ? str2ip(&ip_s) : str2ip6(&ip_s);
	if (!ip_tmp) {
		LM_ERR("Invalid IP\n");
		return -1;
	}
	ip = pkg_malloc(sizeof *ip);
	if (!ip) {
		LM_CRIT("No more pkg memory\n");
		return -1;
	}
	memcpy(ip, ip_tmp, sizeof *ip);

	p = (af == AF_INET) ? q_memchr(p, '.', len-(p-in)+1) : q_memchr(p, ':', len-(p-in)+1);
	if (p) {
		ip_tmp = (af == AF_INET) ? str2ip(&mask_s) : str2ip6(&mask_s);
		if (!ip_tmp) {
			LM_ERR("Invalid netmask\n");
			return -1;
		}
		mask = pkg_malloc(sizeof *mask);
		if (!mask) {
			LM_CRIT("No more pkg memory\n");
			return -1;
		}
		memcpy(mask, ip_tmp, sizeof *mask);

		*ipnet = mk_net(ip, mask);
	} else {
		if (str2int(&mask_s, &bitlen) < 0) {
			LM_ERR("Invalid netmask bitlen\n");
			return -1;
		}

		*ipnet = mk_net_bitlen(ip, bitlen);
	}

	pkg_free(ip);
	pkg_free(mask);

	if (*ipnet == NULL)
			return -1;

	return 0;
}
